package erkka;

import java.awt.*;
import java.awt.Graphics2D;
import java.awt.font.*;
import java.awt.geom.*;
/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  This class defines a symbol in the shape of the diamond </p>
*<p<Copyright:    Copyright (c) 2002</p>
*@author          Antti Enqvist & Juho Yli-Honkola
*@version 1.0
*/

public class Diamond extends Symbol {
/**
* Defines default font (type,size)
*/
  Font f = new Font("Times",Font.PLAIN, 12);
  public Diamond() {
  }
/**
* This function draws a symbol in the shape of the diamond. If object has focus i.e object has
* selected the color of the object is red. This function also draws object name into the object
* @param g
*/
  public void paint(Graphics g){
    super.paint(g);
/**
* The size of the canvas
*/
    int CanvasWidth = this.getWidth(), CanvasHeight = this.getHeight();
/**
* The size of the rectangle
*/
    int RectWidth, RectHeight;

    g2 = (Graphics2D) g;
// if you want to draw thicker line, remove following comments and set new width
//    int width = 1;
//    g2.setStroke(new BasicStroke(width));

    FontRenderContext frc = g2.getFontRenderContext();
    TextLayout tl;
//if the length of the data is zero you have to create an empty textlayout

    if (getFieldData(1).length()==0)
     { tl= new TextLayout(" ", f, frc);}
    else {String s = new String(getFieldData(1)); tl = new TextLayout(s, f, frc);}
    Rectangle2D r2d = tl.getBounds();
    RectWidth = (int)r2d.getWidth()+40;
    RectHeight = this.getHeight()-2;

    if (RectWidth < 80){
      RectWidth = 80;
    }
    CanvasWidth = RectWidth+2;
    tl.draw(g2,20,CanvasHeight/2+f.getSize()/2);
    this.setBounds(getX(),getY(),CanvasWidth,getHeight());

    g2.drawLine(0,getHeight()/2,RectWidth/2,0);
    g2.drawLine(getWidth()/2,0,getWidth(),getHeight()/2);
    g2.drawLine(getWidth()-1,getHeight()/2,getWidth()/2-1,getHeight());
    g2.drawLine(getWidth()/2,getHeight()-1,0,getHeight()/2-1);

    if (obj_focus){
      g2.setColor(Color.red);
      g2.drawRect(0,0,CanvasWidth-1,CanvasHeight-1);
    }


  }
}
