package erkka;
import java.util.EventListener;
import java.awt.AWTEventMulticaster;

/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  This class is a part of our own event</p>
*<p<Copyright:    Copyright (c) 2002</p>
*@author          Antti Enqvist & Juho Yli-Honkola
*@version 1.0
*/
/*
*<h2>Version history</h2>
*<TABLE border="1" width=80%>
*<TR>
*<TD WIDTH="20%"><b>Version</b></td>
*<TD WIDTH="20%"><b>Date</b></td>
*<TD WIDTH="*"><b>Changes</b></td>
*<TD WIDTH="20%"><b>Person</b></td>
*</TR>
*<TR>
*<TD WIDTH="20%">0.0.1</TD>
*<TD WIDTH="20%">03.03.02</TD>
*<TD WIDTH="*">First version</TD>
*<TD WIDTH="20%">AE</TD>
*</TR>
*</TABLE>
*/

public class ErkkaEventMulticaster
extends AWTEventMulticaster
implements ErkkaListener
{

 // public ErkkaEventMulticaster() {
  //}

    protected ErkkaEventMulticaster(EventListener a, EventListener b) {
        super(a, b);
    }
    public static ErkkaListener add(ErkkaListener a, ErkkaListener b) {
        return (ErkkaListener) addInternal(a, b);
    }
    public static ErkkaListener remove(ErkkaListener l,
                                        ErkkaListener oldl) {
        return (ErkkaListener) removeInternal(l,oldl);
    }
    public void Selected(ErkkaEvent e) {
        //casting exception will never occur in this case
        //casting _is_ needed because this multicaster may
        //handle more than just one listener
     ((ErkkaListener) b).Selected(e);

    }
public void PropertyChange(ErkkaEvent e) {
        //casting exception will never occur in this case
        //casting _is_ needed because this multicaster may
        //handle more than just one listener
     ((ErkkaListener) b).PropertyChange(e);

    }

    protected static EventListener addInternal(EventListener a,
                                               EventListener b) {
        if (a == null) return b;
        if (b == null) return a;
        return new ErkkaEventMulticaster(a, b);
    }
    protected EventListener remove(EventListener oldl) {
        if (oldl == a) return b;
        if (oldl == b) return a;
        EventListener a2 = removeInternal(a, oldl);
        EventListener b2 = removeInternal(b, oldl);
        if (a2 == a && b2 == b) return this;
        return addInternal(a2, b2);
    }

}

