package erkka;
// javadocit: progra~1\JBuilder6\jdk1.3.1\jre\bin\javaw -cp C:\progra~1\JBuilder6\jdk1.3.1\lib\tools.jar com.sun.tools.javadoc.Main -sourcepath C:\mytemp\valmis\Erkka\src;C:\mytemp\valmis\Erkka\test -classpath "C:\progra~1\JBuilder6\jdk1.3.1\lib\tools.jar;C:\mytemp\valmis\Erkka\classes;C:\progra~1\JBuilder6\lib\xerces.jar;C:\progra~1\JBuilder6\lib\xalan.jar;C:\progra~1\JBuilder6\lib\jbcl.jar;C:\progra~1\JBuilder6\lib\dx.jar;C:\progra~1\JBuilder6\lib\beandt.jar" -doclet com.sun.tools.doclets.standard.Standard -d C:\mytemp\valmis\Erkka\doc -package erkka
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.undo.*;
import java.awt.print.*;
import javax.swing.filechooser.*;
import java.io.*;
import javax.swing.text.html.*;
import com.borland.jbcl.layout.*;


/**
 * Title:        Erkka-Projekti
 * Description:  MainWindow handles menu and sql,drawing and relation view.
 * Copyright:    Copyright (c) 2002
 * @author        Antti Enqvist & Juho Yli-Honkola. Jukka Mntyl.
 * @version 1.23 2006 Jukka Mntyl. Unzippaa ODB-tiedostosta tietokannan ja ottaa yhteyden. Disconnectin yhteydess pakkaa takaisin ODB-tiedoston. Korjattu Execute-button.
 * @version 1.22 2005 Jukka Mntyl. Korjattu bugi tyhjiss sql:ss ja control.javan org.apache importit muutettu.
 * @version 1.21 2005 Jukka Mntyl. Siirrytty java 1.4:sta kokonaan 1.5:seen.
 * @version 1.2 2005 Jukka Mntyl. SQL- ja Query-paneli yhdistetty. Korjattu bugeja SQL-muuntamisessa. Korjailtu menuja.
 * @version 1.1 2005 Jukka Mntyl. SQL-muunnoskutsua muutettu. Listty Query-paneeli SQL-tietokantayhteyksille.
 * @version 1.0
 * @todo ODBCQuery controlliin
 */

public class MainWindow extends JFrame {
  JPanel contentPane;
  Control command;
  ODBCQuery query; // pitisi siirt controlliin tms.
  MainWindow_ConnectODBC dlg;
  /**
   * undo system elements
   */
  protected UndoManager undoManager = new UndoManager();  // history list
  protected UndoableEditSupport undoSupport = new UndoableEditSupport(); // event support


  JScrollPane scroll =new JScrollPane();
  JScrollPane helpScroll =new JScrollPane();

  DrawingArea Darea = new DrawingArea();
  TopPanel TopPanel = new TopPanel();
  JFrame helpFrame = new JFrame("Erkka manual");
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  InformationPanel infoPanel = new InformationPanel();
  JTabbedPane tabPane = new JTabbedPane(JTabbedPane.BOTTOM);
  JMenuBar jMenuBarDrawing = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuNew = new JMenuItem();
  JMenu jMenuEdit = new JMenu();
  JMenuItem jMenuUndo = new JMenuItem();
  JMenu jMenuView = new JMenu();
  JMenu jMenuOption = new JMenu();
  JMenu jMenuInsert = new JMenu();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuManual = new JMenuItem();
  JMenuItem jMenuEntity = new JMenuItem();
  JMenuItem jMenuRelationship = new JMenuItem();
  JMenuItem jMenuAttribute = new JMenuItem();
  JMenuItem jMenuLine = new JMenuItem();
  JMenuItem jMenuRedo = new JMenuItem();
  JRadioButtonMenuItem jMenuDrawing = new JRadioButtonMenuItem();

  JMenuItem jMenuOpen = new JMenuItem();
  JMenuItem jMenuClose = new JMenuItem();
  JMenuItem jMenuSave = new JMenuItem();
  JMenuItem jMenuSaveAs = new JMenuItem();
  JMenuItem jMenuPrint = new JMenuItem();
  JMenuItem jMenuExport = new JMenuItem();
  JMenuItem jMenuExit = new JMenuItem();
  JMenuItem jMenuDelete = new JMenuItem();
  JMenuItem jMenuSelectAll = new JMenuItem();
  JMenu jMenuColor = new JMenu();
  JMenuItem jMenuAbout = new JMenuItem();


  ButtonGroup group = new ButtonGroup();

//submenus
  JMenuItem jMenuBackground = new JMenuItem();
  JMenuItem jMenuColorLine = new JMenuItem();
  JCheckBoxMenuItem jMenuHideAllLineSpot = new JCheckBoxMenuItem();
  JFileChooser fc = new JFileChooser();
  File file;
  JMenuItem jMenuColorInfo = new JMenuItem();
  JMenuItem jMenuColorSelected = new JMenuItem();
  JPanel drawingPanel = new JPanel();
  RelDrawingPanel relationPanel = new RelDrawingPanel();
  MainWindow_AboutBox about = new MainWindow_AboutBox(this);
  JMenuBar jMenuBarDrawingRelation = new JMenuBar();
  JMenuItem jMenuExit2 = new JMenuItem();
  JMenuItem jMenuPrint2 = new JMenuItem();
  JMenu jMenuFile3 = new JMenu();
  JMenuItem jMenuExport2 = new JMenuItem();
  JMenuItem jMenuItem1 = new JMenuItem();
  JEditorPane helpviewer=new JEditorPane();
  JPanel queryPanel = new JPanel();

  BorderLayout borderLayout3 = new BorderLayout();
  JPanel sqlHeaderPanel = new JPanel();
  JPanel actionAreaPanel = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JScrollPane sqlScroll = new JScrollPane();
  JPanel resultAreaPanel = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane resultScroll = new JScrollPane();
  JTextArea sqlText = new JTextArea();
  JTextArea resultText = new JTextArea();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton executeButton = new JButton();
  JToggleButton connectionInfoButton = new JToggleButton();

  JRadioButtonMenuItem jMenuRelation = new JRadioButtonMenuItem();
  JRadioButtonMenuItem jMenuQuery = new JRadioButtonMenuItem();
  JMenuItem jMenuSelectAll2 = new JMenuItem();
  JMenuItem jMenuAbout3 = new JMenuItem();
  JMenuBar jMenuBarDrawingQuery = new JMenuBar();
  JMenu jMenuFile2 = new JMenu();
  JMenu jMenuEdit2 = new JMenu();
  JMenuItem jMenuCopy2 = new JMenuItem();
  JMenuItem jMenuCut2 = new JMenuItem();
  JMenu jMenuHelp2 = new JMenu();
  JMenuItem jMenuPaste2 = new JMenuItem();
  JMenuItem jMenuManual3 = new JMenuItem();
  JRadioButtonMenuItem jMenuDrawing3 = new JRadioButtonMenuItem();
  JMenu jMenuView2 = new JMenu();
  JRadioButtonMenuItem jMenuRelation3 = new JRadioButtonMenuItem();
  JRadioButtonMenuItem jMenuQuery3 = new JRadioButtonMenuItem();
  JMenuItem jMenuSaveAs2 = new JMenuItem();
  JMenuItem jMenuSaveAs3 = new JMenuItem();
  JPanel erkkaInfoPanel = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JMenu jMenuEdit3 = new JMenu();
  JRadioButtonMenuItem jMenuDrawing2 = new JRadioButtonMenuItem();
  JRadioButtonMenuItem jMenuQuery2 = new JRadioButtonMenuItem();
  JMenu jMenuView3 = new JMenu();
  JRadioButtonMenuItem jMenuRelation2 = new JRadioButtonMenuItem();
  JMenuItem jMenuManual2 = new JMenuItem();
  JMenu jMenuHelp3 = new JMenu();
  JMenuItem jMenuAbout2 = new JMenuItem();
  JMenuItem jMenuUpdateRelation = new JMenuItem();
  JMenuItem jMenuExit3 = new JMenuItem();
  JMenuItem jMenuOpenDB = new JMenuItem();
  JMenuItem jMenuConnectDB = new JMenuItem();
  JMenuItem jMenuOpenSQL = new JMenuItem();
  JMenuItem jMenuDisconnectDB = new JMenuItem();
  JMenu jMenuQueries = new JMenu();
  JMenuItem jMenuExecute = new JMenuItem();
  JMenuItem jMenuTransform = new JMenuItem();
  JMenuItem jMenuClear = new JMenuItem();
  JMenuItem jMenuPrint3 = new JMenuItem();
  /** Construct the frame */
  public MainWindow() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Component initialization */
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(MainWindow.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    helpFrame.pack();
    helpFrame.getContentPane().setLayout(new BoxLayout(helpFrame.getContentPane(),BoxLayout.X_AXIS));
    helpviewer.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
      public void hyperlinkUpdate(HyperlinkEvent e) {
        helpviewer_hyperlinkUpdate(e);
      }
    });
    queryPanel.setLayout(borderLayout3);
    queryPanel.setMaximumSize(new Dimension(2147483647, 10000));
    queryPanel.setMinimumSize(new Dimension(44, 10074));
    sqlHeaderPanel.setMaximumSize(new Dimension(2147483647, 2147483647));
    sqlHeaderPanel.setPreferredSize(new Dimension(10, 50));
    sqlHeaderPanel.setLayout(gridBagLayout2);
    actionAreaPanel.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    resultAreaPanel.setLayout(borderLayout1);
    sqlText.setFont(new java.awt.Font("Courier New", 0, 12));
    sqlText.setText("");
    jLabel1.setText("SQL-statements:");
    jLabel2.setText("Results:                 ");
    executeButton.setEnabled(false);
    executeButton.setText("Execute");
    executeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        executeButton_actionPerformed(e);
      }
    });
    connectionInfoButton.setBackground(UIManager.getColor("info"));
    connectionInfoButton.setFont(new java.awt.Font("Bitstream Vera Sans", 0, 11));
    connectionInfoButton.setBorder(BorderFactory.createLoweredBevelBorder());
    connectionInfoButton.setToolTipText("");
    connectionInfoButton.setFocusable(false);
    connectionInfoButton.setText("Not connected");

    jMenuRelation.setMargin(new Insets(2, 0, 2, 2));
    jMenuRelation.setText("Relation");
    jMenuRelation.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuRelation_actionPerformed(e);
      }
    });
    jMenuQuery.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuQuery_actionPerformed(e);
      }
    });
    jMenuQuery.setActionCommand("Query");
    jMenuQuery.setMargin(new Insets(2, 0, 2, 2));
    jMenuQuery.setText("Query");
    jMenuSelectAll2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuSelectAll2_actionPerformed(e);
      }
    });
    jMenuSelectAll2.setAccelerator(KeyStroke.getKeyStroke('A', java.awt.Event.CTRL_MASK));
    jMenuSelectAll2.setMargin(new Insets(2, -10, 2, 2));
    jMenuSelectAll2.setText("Select All");
    jMenuAbout3.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("About24.gif")));
    jMenuAbout3.setMargin(new Insets(2, -10, 2, 2));
    jMenuAbout3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuAbout1_actionPerformed(e);
      }
    });
    jMenuAbout3.setText("About");
    jMenuFile2.setText("File");
    jMenuFile2.setAlignmentX((float) 0.5);
    jMenuFile2.setHorizontalAlignment(SwingConstants.LEADING);
    jMenuFile2.setHorizontalTextPosition(SwingConstants.TRAILING);
    jMenuFile2.setMnemonic('F');
    jMenuEdit2.setText("Edit");
    jMenuEdit2.setMnemonic('E');
    jMenuCopy2.setAccelerator(KeyStroke.getKeyStroke('C',java.awt.Event.CTRL_MASK));
    jMenuCopy2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuCopy2_actionPerformed(e);
      }
    });
    jMenuCopy2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Copy24.gif")));
    jMenuCopy2.setMargin(new Insets(2, -10, 2, 2));
    jMenuCopy2.setText("Copy");
    jMenuCut2.setText("Cut");
    jMenuCut2.setActionCommand("Cut");
    jMenuCut2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Cut24.gif")));
    jMenuCut2.setMargin(new Insets(2, -10, 2, 2));
    jMenuCut2.setAccelerator(KeyStroke.getKeyStroke('X',java.awt.Event.CTRL_MASK));
    jMenuCut2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuCut2_actionPerformed(e);
      }
    });
    jMenuHelp2.setText("Help");
    jMenuHelp2.setMnemonic('H');
    jMenuPaste2.setAccelerator(KeyStroke.getKeyStroke('V',java.awt.Event.CTRL_MASK));
    jMenuPaste2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuPaste2_actionPerformed(e);
      }
    });
    jMenuPaste2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Paste24.gif")));
    jMenuPaste2.setMargin(new Insets(2, -10, 2, 2));
    jMenuPaste2.setText("Paste");
    jMenuManual3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuManual_actionPerformed(e);
      }
    });
    jMenuManual3.setMargin(new Insets(2, -10, 2, 2));
    jMenuManual3.setText("Manual");
    jMenuDrawing3.setMargin(new Insets(2, 0, 2, 2));
    jMenuDrawing3.setSelected(false);
    jMenuDrawing3.setText("Drawing");
    jMenuDrawing3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuDrawing_actionPerformed(e);
      }
    });
    jMenuView2.setMnemonic('V');
    jMenuView2.setText("View");
    jMenuRelation3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuRelation_actionPerformed(e);
      }
    });
    jMenuRelation3.setMargin(new Insets(2, 0, 2, 2));
    jMenuRelation3.setText("Relation");
    jMenuQuery3.setActionCommand("Query");
    jMenuQuery3.setMargin(new Insets(2, 0, 2, 2));
    jMenuQuery3.setSelected(true);
    jMenuQuery3.setText("Query");
    jMenuQuery3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuQuery_actionPerformed(e);
      }
    });
    resultText.setFont(new java.awt.Font("Courier New", 0, 12));
    resultText.setText("Select Query | ER to SQL (F5) to convert ER-diagram into SQL-statements.\n\nSelect View | Relation and Edit | SQL to Relation (F5) to convert SQL into relation-diagram.");
    resultText.setTabSize(16);
    jMenuSaveAs2.setText("Save SQL As...");
    jMenuSaveAs2.setActionCommand("Save SQL As...");
    jMenuSaveAs2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("SaveAs24.gif")));
    jMenuSaveAs2.setMargin(new Insets(2, -10, 2, 2));
    jMenuSaveAs2.setMnemonic('S');
    jMenuSaveAs2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuSaveAs2_actionPerformed(e);
      }
    });
    jMenuSaveAs3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuSaveAs3_actionPerformed(e);
      }
    });
    jMenuSaveAs3.setMnemonic('R');
    jMenuSaveAs3.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("SaveAs24.gif")));
    jMenuSaveAs3.setMargin(new Insets(2, -10, 2, 2));
    jMenuSaveAs3.setActionCommand("Save Results As...");
    jMenuSaveAs3.setText("Save Results As...");
    erkkaInfoPanel.setFont(new java.awt.Font("Gill Sans MT", 0, 12));
    erkkaInfoPanel.setLayout(verticalFlowLayout1);
    jLabel5.setText("CTRL = select/move multiple objects");
    jLabel5.setFont(new java.awt.Font("Dialog", 0, 9));
    jLabel3.setFont(new java.awt.Font("Gill Sans MT", 1, 12));
    jLabel3.setText("Erkka 1.23");
    jMenuEdit3.setMnemonic('E');
    jMenuEdit3.setText("Edit");
    jMenuDrawing2.setMargin(new Insets(2, 0, 2, 2));
    jMenuDrawing2.setText("Drawing");
    jMenuDrawing2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuDrawing_actionPerformed(e);
      }
    });

    jMenuQuery2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuQuery_actionPerformed(e);
      }
    });
    jMenuQuery2.setAction(null);
    jMenuQuery2.setActionCommand("Query");
    jMenuQuery2.setMargin(new Insets(2, 0, 2, 2));
    jMenuQuery2.setText("Query");
    jMenuView3.setMnemonic('V');
    jMenuView3.setText("View");
    jMenuRelation2.setMargin(new Insets(2, 0, 2, 2));
    jMenuRelation2.setSelected(true);
    jMenuRelation2.setText("Relation");
    jMenuRelation2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuRelation_actionPerformed(e);
      }
    });
    jMenuManual2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuManual2_actionPerformed(e);
      }
    });
    jMenuManual2.setMargin(new Insets(2, -10, 2, 2));
    jMenuManual2.setText("Manual");
    jMenuHelp3.setText("Help");
    jMenuHelp3.setMnemonic('H');
    jMenuAbout2.setText("About");
    jMenuAbout2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuAbout1_actionPerformed(e);
      }
    });
    jMenuAbout2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("About24.gif")));
    jMenuAbout2.setMargin(new Insets(2, -10, 2, 2));
    jMenuUpdateRelation.setAccelerator(javax.swing.KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0, false));
    jMenuUpdateRelation.setActionCommand("SQL to Relation");
    jMenuUpdateRelation.setMargin(new Insets(2, -10, 2, 2));
    jMenuUpdateRelation.setText("SQL to Relation");
    jMenuUpdateRelation.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuUpdateRelation_actionPerformed(e);
      }
    });
    jMenuExit3.setText("Exit");
    jMenuExit3.setAccelerator(KeyStroke.getKeyStroke('Q',java.awt.Event.CTRL_MASK));
    jMenuExit3.setMargin(new Insets(2, -10, 2, 2));
    jMenuExit3.setMnemonic('X');
    jMenuExit3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });
    jMenuOpenDB.setMnemonic('D');
    jMenuOpenDB.setText("Open database...");
    jMenuOpenDB.setPreferredSize(new Dimension(145, 29));
    jMenuOpenDB.setHorizontalAlignment(SwingConstants.LEADING);
    jMenuOpenDB.setHorizontalTextPosition(SwingConstants.TRAILING);
    jMenuOpenDB.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Open24.gif")));
    jMenuOpenDB.setMargin(new Insets(2, -10, 2, 2));
    jMenuOpenDB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuOpenDB_actionPerformed(e);
      }
    });
    jMenuConnectDB.setMargin(new Insets(2, -10, 2, 2));
    jMenuConnectDB.setMnemonic('C');
    jMenuConnectDB.setText("Connect to database...");
    jMenuConnectDB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuConnectDB_actionPerformed(e);
      }
    });
    jMenuOpenSQL.setMnemonic('O');
    jMenuOpenSQL.setText("Open SQL...");
    jMenuOpenSQL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuOpenSQL_actionPerformed(e);
      }
    });
    jMenuOpenSQL.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Open24.gif")));
    jMenuOpenSQL.setMargin(new Insets(2, -10, 2, 2));
    jMenuDisconnectDB.setMargin(new Insets(2, -10, 2, 2));
    jMenuDisconnectDB.setMnemonic('D');
    jMenuDisconnectDB.setText("Disconnect");
    jMenuDisconnectDB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuDisconnectDB_actionPerformed(e);
      }
    });
    jMenuQueries.setMnemonic('Q');
    jMenuQueries.setText("Query");
    jMenuExecute.setAccelerator(javax.swing.KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0, false));
    jMenuExecute.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuExecute_actionPerformed(e);
      }
    });
    jMenuExecute.setMargin(new Insets(2, -10, 2, 2));
    jMenuExecute.setMnemonic('E');
    jMenuExecute.setText("Execute");
    jMenuTransform.setMargin(new Insets(2, -10, 2, 2));
    jMenuTransform.setMnemonic('S');
    jMenuTransform.setText("ER to SQL");
    jMenuTransform.setAccelerator(javax.swing.KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0, false));
    jMenuTransform.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuTransform_actionPerformed(e);
      }
    });
    jMenuExport2.setMargin(new Insets(2, -10, 2, 2));
    jMenuPrint2.setMargin(new Insets(2, -10, 2, 2));
    jMenuExit2.setMargin(new Insets(2, -10, 2, 2));
    jMenuNew.setMargin(new Insets(2, -10, 2, 2));
    jMenuOpen.setMargin(new Insets(2, -10, 2, 2));
    jMenuClose.setMargin(new Insets(2, -10, 2, 2));
    jMenuSave.setMargin(new Insets(2, -10, 2, 2));
    jMenuSaveAs.setMargin(new Insets(2, -10, 2, 2));
    jMenuPrint.setMargin(new Insets(2, -10, 2, 2));
    jMenuExport.setMargin(new Insets(2, -10, 2, 2));
    jMenuExit.setMargin(new Insets(2, -10, 2, 2));
    jMenuUndo.setMargin(new Insets(2, -10, 2, 2));
    jMenuRedo.setMargin(new Insets(2, -10, 2, 2));
    jMenuDelete.setMargin(new Insets(2, -10, 2, 2));
    jMenuSelectAll.setMargin(new Insets(2, -10, 2, 2));
    jMenuItem1.setMargin(new Insets(2, -10, 2, 2));
    jMenuDrawing.setMargin(new Insets(2, 0, 2, 2));
    jMenuColor.setMargin(new Insets(2, 0, 2, 2));
    jMenuBackground.setMargin(new Insets(2, -10, 2, 2));
    jMenuColorLine.setMargin(new Insets(2, -10, 2, 2));
    jMenuColorInfo.setMargin(new Insets(2, -10, 2, 2));
    jMenuColorSelected.setMargin(new Insets(2, -10, 2, 2));
    jMenuHideAllLineSpot.setMargin(new Insets(2, 0, 2, 2));
    jMenuEntity.setMargin(new Insets(2, -10, 2, 2));
    jMenuRelationship.setMargin(new Insets(2, -10, 2, 2));
    jMenuAttribute.setMargin(new Insets(2, -10, 2, 2));
    jMenuLine.setMargin(new Insets(2, -10, 2, 2));
    jMenuManual.setMargin(new Insets(2, -10, 2, 2));
    jMenuAbout.setMargin(new Insets(2, -10, 2, 2));
    jMenuClear.setAccelerator(javax.swing.KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuClear.setMargin(new Insets(2, -10, 2, 2));
    jMenuClear.setText("Clear SQL");
    jMenuClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuClear_actionPerformed(e);
      }
    });
    jMenuPrint3.setMargin(new Insets(2, -10, 2, 2));
    jMenuPrint3.setMnemonic('P');
    jMenuPrint3.setText("Print");
    jMenuPrint3.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Print24.gif")));
    jMenuPrint3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuPrint3_actionPerformed(e);
      }
    });
    helpFrame.getContentPane().add(helpviewer);

    helpFrame.setVisible(false);
    //helpFrame.
    drawingPanel.setLayout(gridBagLayout1);
    relationPanel.setLayout( new BoxLayout(relationPanel, BoxLayout.X_AXIS ) );
    this.getContentPane().setBackground(Color.gray);
    this.setSize(new Dimension(665, 595));
    this.setTitle("Erkka");
    Darea.setBackground(Color.white);
    Darea.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentMoved(ComponentEvent e) {
        Darea_componentMoved(e);
      }
    });

    this.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) { keyType(e);}
      });
    Darea.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        Darea_mousePressed(e);
      }
    });
    TopPanel.setBackground(SystemColor.activeCaptionBorder);

    jMenuFile.setText("File");
    jMenuFile.setMnemonic('F');
    jMenuEdit.setText("Edit");
    jMenuEdit.setMnemonic('E');
    jMenuView.setText("View");
    jMenuView.setMnemonic('V');
    jMenuOption.setText("Options");
    jMenuOption.setMnemonic('O');
    jMenuInsert.setText("Insert");
    jMenuInsert.setMnemonic('I');
    jMenuHelp.setText("Help");
    jMenuHelp.setMnemonic('H');

    jMenuManual.setText("Manual");
    jMenuManual.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuManual_actionPerformed(e);
      }
    });

    jMenuEntity.setText("Entity");
    jMenuEntity.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        insert_actionPerformed(e);
      }
    });
    jMenuRelationship.setText("Relationship");
    jMenuRelationship.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        insert_actionPerformed(e);
      }
    });
    jMenuAttribute.setText("Attribute");
    jMenuAttribute.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        insert_actionPerformed(e);
      }
    });
    jMenuLine.setText("Line");
    jMenuLine.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        insert_actionPerformed(e);
      }
    });


    jMenuDrawing.setText("Drawing");
    jMenuDrawing.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuDrawing_actionPerformed(e);
      }
    });


    jMenuNew.setText("New ");
    jMenuNew.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("New24.gif")));
    jMenuNew.setAccelerator( KeyStroke.getKeyStroke('N',java.awt.Event.CTRL_MASK));
    jMenuNew.setMnemonic('N');
    jMenuNew.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuNew_actionPerformed(e);
      }
    });

    jMenuOpen.setText("Open");
    jMenuOpen.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Open24.gif")));
    jMenuOpen.setAccelerator( KeyStroke.getKeyStroke('O',java.awt.Event.CTRL_MASK));
    jMenuOpen.setMnemonic('O');
    jMenuOpen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuOpen_actionPerformed(e);
      }
    });
    jMenuClose.setHorizontalAlignment(SwingConstants.LEFT);
    jMenuClose.setHorizontalTextPosition(SwingConstants.LEFT);
    jMenuClose.setText("Close");
    jMenuClose.setMnemonic('C');
    jMenuClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuClose_actionPerformed(e);
      }
    });
    jMenuSave.setText("Save");
    jMenuSave.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Save24.gif")));
    jMenuSave.setAccelerator( KeyStroke.getKeyStroke('S',java.awt.Event.CTRL_MASK));
    jMenuSave.setMnemonic('S');
    jMenuSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuSave_actionPerformed(e);
      }
    });
    jMenuSaveAs.setText("Save As...");
    jMenuSaveAs.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("SaveAs24.gif")));
    jMenuSaveAs.setMnemonic('v');
    jMenuSaveAs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuSaveAs_actionPerformed(e);
      }
    });
    jMenuPrint.setText("Print");
    jMenuPrint.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Print24.gif")));
    jMenuPrint.setMnemonic('I');
    jMenuPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuPrint_actionPerformed(e);
      }
    });
    jMenuExport.setText("Export to PNG...");
    jMenuExport.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Export24.gif")));
    jMenuExport.setMnemonic('E');
    jMenuExport.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuExport_actionPerformed(e);
      }
    });
    jMenuExit.setText("Exit");
    jMenuExit.setAccelerator( KeyStroke.getKeyStroke('Q',java.awt.Event.CTRL_MASK));
    jMenuExit.setMnemonic('X');
    jMenuExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });


    jMenuUndo.setText("Undo");
    jMenuUndo.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Undo24.gif")));
    jMenuUndo.setAccelerator( KeyStroke.getKeyStroke('Z',java.awt.Event.CTRL_MASK));
    jMenuUndo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuEditUndo_actionPerformed(e);
      }
    });

    jMenuRedo.setText("Redo");
    jMenuRedo.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Redo24.gif")));
    jMenuRedo.setAccelerator( KeyStroke.getKeyStroke('Z',java.awt.Event.CTRL_MASK + java.awt.Event.SHIFT_MASK));
    jMenuRedo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuEditRedo_actionPerformed(e);
      }
    });





    jMenuDelete.setText("Delete");
    jMenuDelete.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Remove24.gif")));
    jMenuDelete.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
    jMenuDelete.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuEditDelete_actionPerformed(e);
      }
    });

    jMenuSelectAll.setText("Select All");
    jMenuSelectAll.setAccelerator( KeyStroke.getKeyStroke('A', java.awt.Event.CTRL_MASK));
    jMenuSelectAll.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuEditSelectAll_actionPerformed(e);
      }
    });


    jMenuColor.setText("Color");

    jMenuBackground.setText("Background");
    jMenuBackground.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuBackground_actionPerformed(e);
      }
    });
    jMenuColorLine.setText("Line");
    jMenuColorLine.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuColorLine_actionPerformed(e);
      }
    });

    jMenuAbout.setText("About");
    jMenuAbout.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuAbout1_actionPerformed(e);
      }
    });
    jMenuAbout.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("About24.gif")));

    jMenuHideAllLineSpot.setText("HideAllHotSpots");
    jMenuHideAllLineSpot.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuHideAllLineSpot_actionPerformed(e);
      }
    });
    fc.setBounds(new Rectangle(44, 100, 393, 236));
    infoPanel.setBackground(SystemColor.activeCaptionBorder);
    jMenuColorInfo.setText("Infopanel");
    jMenuColorInfo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuColorInfo_actionPerformed(e);
      }
    });
    jMenuColorSelected.setText("Selected objects");
    jMenuColorSelected.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuColorSelected_actionPerformed(e);
      }
    });
    drawingPanel.setMinimumSize(new Dimension(100, 100));
    drawingPanel.setBounds(new Rectangle(0,0,getWidth(),getHeight()));
    relationPanel.setToolTipText("Refresh image by pressing F5");
    contentPane.setLayout( new BoxLayout(contentPane, BoxLayout.X_AXIS) );

    // Create menu bar
    jMenuExit2.setText("Exit");
    jMenuExit2.setAccelerator(KeyStroke.getKeyStroke('Q',java.awt.Event.CTRL_MASK));
    jMenuExit2.setMnemonic('X');
    jMenuExit2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });
    jMenuPrint2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuPrint2_actionPerformed(e);
      }
    });
    jMenuPrint2.setMnemonic('I');
    jMenuPrint2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("Print24.gif")));
    jMenuPrint2.setText("Print");
    jMenuFile3.setText("File");
    jMenuFile3.setMnemonic('F');
    jMenuExport2.setText("Export to PNG...");
    jMenuExport2.setActionCommand("");
    jMenuExport2.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("SaveAs24.gif")));
    jMenuExport2.setMnemonic('E');
    jMenuExport2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuExport2_actionPerformed(e);
      }
    });
    jMenuItem1.setText("Edit");
    jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(113, 0, false));
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    jMenuBarDrawing.add(jMenuFile);
    jMenuBarDrawing.add(jMenuEdit);
    jMenuBarDrawing.add(jMenuView);
    jMenuBarDrawing.add(jMenuOption);
    jMenuBarDrawing.add(jMenuInsert);
    jMenuBarDrawing.add(jMenuHelp);


    // File - menu
    jMenuFile.add(jMenuNew);
    jMenuFile.add(jMenuOpen);
    jMenuFile.add(jMenuClose);
    jMenuFile.addSeparator();

    jMenuFile.add(jMenuSave);
    jMenuFile.add(jMenuSaveAs);
    jMenuFile.addSeparator();

    jMenuFile.add(jMenuPrint);
    jMenuFile.add(jMenuExport);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuExit);

    jMenuEdit.add(jMenuUndo);
    jMenuEdit.add(jMenuRedo);
    jMenuEdit.addSeparator();

    jMenuEdit.add(jMenuDelete);

    jMenuEdit.add(jMenuSelectAll);
    jMenuEdit.add(jMenuItem1);
    jMenuHelp.add(jMenuManual);
    jMenuHelp.add(jMenuAbout);
    jMenuInsert.add(jMenuEntity);
    jMenuInsert.add(jMenuRelationship);
    jMenuInsert.add(jMenuAttribute);
    jMenuInsert.add(jMenuLine);

    jMenuView.add(jMenuDrawing);
    jMenuDrawing.setSelected(true);
    group.add(jMenuDrawing);
    jMenuView.add(jMenuQuery);
    jMenuView.add(jMenuRelation);

    jMenuOption.add(jMenuColor);
    jMenuOption.add(jMenuHideAllLineSpot);
    jMenuColor.add(jMenuBackground);
    jMenuColor.add(jMenuColorLine);
    jMenuColor.add(jMenuColorInfo);
    jMenuColor.add(jMenuColorSelected);

    drawingPanel.add(TopPanel,               new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 20));
    drawingPanel.add(scroll,                                           new GridBagConstraints(2, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(1, 1, 1, 1), 508, 0));
    scroll.getViewport().add(Darea, BorderLayout.CENTER);
    drawingPanel.add(infoPanel,                                              new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTHEAST, GridBagConstraints.VERTICAL, new Insets(1, 2, 0, 5), 153, 744));
    drawingPanel.add(erkkaInfoPanel,       new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(1, 2, 0, 0), 0, 0));

    //helpviewer.add(helpScroll,null);
    helpFrame.getContentPane().add(helpScroll,null);
    helpScroll.getViewport().add(helpviewer,BorderLayout.CENTER);
    helpFrame.setSize(getWidth(),getHeight());
    //<KKL
    tabPane.addTab( "Drawing", drawingPanel );
    tabPane.addTab( "Query", queryPanel);
    queryPanel.add(sqlHeaderPanel, BorderLayout.NORTH);
    sqlHeaderPanel.add(jLabel1,                new GridBagConstraints(0, 1, 1, 1, 0.0, 0.2
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    sqlHeaderPanel.add(connectionInfoButton,       new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(6, 0, 0, 0), 0, 0));
    sqlHeaderPanel.add(executeButton,      new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 12, 0, 0), 0, 0));
    queryPanel.add(actionAreaPanel, BorderLayout.CENTER);
    actionAreaPanel.add(sqlScroll, null);
    sqlScroll.getViewport().add(sqlText, null);
    actionAreaPanel.add(resultAreaPanel, null);
    resultAreaPanel.add(resultScroll, BorderLayout.CENTER);
    resultAreaPanel.add(jLabel2, BorderLayout.NORTH);
    tabPane.addTab( "Relation", relationPanel);
    resultScroll.getViewport().add(resultText, null);

    tabPane.addChangeListener( new ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        tab_stateChanged(e);
      }
    });
    tabPane.setOpaque(true);
    contentPane.add( tabPane );

//KKL>


    contentPane.add(fc, null);
    fc.setVisible(false);
    jMenuOption.add(jMenuColor);

    command = new Control(Darea,TopPanel,infoPanel);
    command.setUndoListener( new UndoAdapter() );
    jMenuBarDrawingRelation.add(jMenuFile3);
    jMenuBarDrawingRelation.add(jMenuEdit3);
    jMenuBarDrawingRelation.add(jMenuView3);
    jMenuBarDrawingRelation.add(jMenuHelp3);
    jMenuFile3.add(jMenuExport2);
    jMenuFile3.add(jMenuPrint2);
    jMenuFile3.addSeparator();
    jMenuFile3.add(jMenuExit2);
    jMenuBarDrawingQuery.add(jMenuFile2);
    jMenuBarDrawingQuery.add(jMenuEdit2);
    jMenuBarDrawingQuery.add(jMenuView2);
    jMenuBarDrawingQuery.add(jMenuQueries);
    jMenuBarDrawingQuery.add(jMenuHelp2);
    jMenuEdit2.add(jMenuCut2);
    jMenuEdit2.add(jMenuCopy2);
    jMenuEdit2.add(jMenuPaste2);
    jMenuEdit2.addSeparator();
    jMenuEdit2.add(jMenuClear);
    jMenuEdit2.add(jMenuSelectAll2);
    jMenuHelp2.add(jMenuManual3);
    jMenuHelp2.add(jMenuAbout3);
    jMenuView2.add(jMenuDrawing3);
    jMenuView2.add(jMenuQuery3);
    jMenuView2.add(jMenuRelation3);
    erkkaInfoPanel.add(jLabel3, null);
    erkkaInfoPanel.add(jLabel5, null);
    jMenuView3.add(jMenuDrawing2);
    jMenuView3.add(jMenuQuery2);
    jMenuView3.add(jMenuRelation2);
    jMenuHelp3.add(jMenuManual2);
    jMenuHelp3.add(jMenuAbout2);
    jMenuEdit3.add(jMenuUpdateRelation);
    jMenuFile2.add(jMenuOpenDB);
    jMenuFile2.add(jMenuConnectDB);
    jMenuFile2.add(jMenuDisconnectDB);
    jMenuFile2.addSeparator();
    jMenuFile2.add(jMenuOpenSQL);
    jMenuFile2.add(jMenuSaveAs2);
    jMenuFile2.add(jMenuSaveAs3);
    jMenuFile2.addSeparator();
    jMenuFile2.add(jMenuPrint3);
    jMenuFile2.add(jMenuExit3);
    jMenuQueries.add(jMenuExecute);
    jMenuQueries.add(jMenuTransform);
    setJMenuBar(jMenuBarDrawing);
    setViewMenu(0);

  }
  /**
   * @todo Aikamoista spagettia, kai thn menusysteemiinkin olis joku jrkevmpi tapa,
   *       esim. yksi menu ja sielt nytetn sitten tarpeelliset
   * @param i int
   */
  public void setViewMenu( int i ) {

    switch (i) {
    case 0:
      this.jMenuDrawing.setSelected(true);

      this.jMenuDrawing2.setSelected(true);
      this.jMenuDrawing3.setSelected(true);

      this.jMenuRelation.setSelected(false);

      this.jMenuRelation2.setSelected(false);
      this.jMenuRelation3.setSelected(false);
      this.jMenuQuery.setSelected(false);

      this.jMenuQuery2.setSelected(false);
      this.jMenuQuery3.setSelected(false);
      break;
    case 1:
      this.jMenuDrawing.setSelected(false);

      this.jMenuDrawing2.setSelected(false);
      this.jMenuDrawing3.setSelected(false);
      this.jMenuRelation.setSelected(false);

      this.jMenuRelation2.setSelected(false);
      this.jMenuRelation3.setSelected(false);
      this.jMenuQuery.setSelected(false);

      this.jMenuQuery2.setSelected(false);
      this.jMenuQuery3.setSelected(false);

      break;


    case 2:
      this.jMenuDrawing.setSelected(false);

      this.jMenuDrawing2.setSelected(false);
      this.jMenuDrawing3.setSelected(false);
      this.jMenuRelation.setSelected(true);

      this.jMenuRelation2.setSelected(true);
      this.jMenuRelation3.setSelected(true);
      this.jMenuQuery.setSelected(false);

      this.jMenuQuery2.setSelected(false);
      this.jMenuQuery3.setSelected(false);
      break;
    case 3:
      this.jMenuDrawing.setSelected(false);

      this.jMenuDrawing2.setSelected(false);
      this.jMenuDrawing3.setSelected(false);

      this.jMenuRelation.setSelected(false);

      this.jMenuRelation2.setSelected(false);
      this.jMenuRelation3.setSelected(false);
      this.jMenuQuery.setSelected(true);

      this.jMenuQuery2.setSelected(true);
      this.jMenuQuery3.setSelected(true);


      break;
    }
  }

  public void tab_stateChanged(ChangeEvent e) {
    JTabbedPane tab = (JTabbedPane)e.getSource();
    if ( tab == null) return;
    switch (tab.getSelectedIndex()) {
      case 0:
        this.setJMenuBar(jMenuBarDrawing);
        this.setViewMenu(0);
        break;
      case 1:
        this.setJMenuBar(jMenuBarDrawingQuery);
        this.setViewMenu(3);
        //if (sqlText.getText().length()<2)
        //updateSQL(); //if sql Tab is clicked first time
          // if drawing not change we need not generate sql again

        break;
      case 2:
        this.setJMenuBar(jMenuBarDrawingRelation);
        this.setViewMenu(2);
        relationPanel.setBounds(0,0,getWidth(),getHeight());
        if (relationPanel.getComponentCount()<1) jMenuUpdateRelation_actionPerformed(null);
        //if(sqlArea.mo  command.isDravingModifiedAfterLastAsking()){
        //  command.makesql(sqlArea);
        break;

      default:
        break;
    };
  }

  /**File | Exit action performed*/
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    // onko tietokantayhteys auki?
    if (query != null) {
      try {
        query.disconnect();
      } catch (Exception ex) {
        MessageBox m = new MessageBox();
        m.setTitle("Error saving database");
        m.askOkay(ex.getLocalizedMessage());
      }
    }
    // Check if we have unsaved drawing?
    if ( !Darea.getModified() )
      System.exit(0);

    // Show dialog box
    MessageBox box = new MessageBox(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        YesNoDialog_actionPerformed(e);
      }
    });
    box.setTitle("Exiting...");
    box.addChoice("Yes", 'Y');
    box.addChoice("No", 'N');
    box.addChoice("Cancel", 'C' );
    box.ask("Do you want to save the modified drawing?");
  }


  public void YesNoDialog_actionPerformed(ActionEvent evt) {
    String command = evt.getActionCommand();

    if (command.equals("Yes")) {
      // First save the job
      jMenuSave_actionPerformed(null);
      // Then exit the application
      System.exit(0);
    } else if(command.equals("No")) {
      // Exit the application
      System.exit(0);
    } else if(command.equals("Cancel") || command.equals("Close")) {
      // Do nothing
    }
  }

  /**Help | About action performed*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    MainWindow_AboutBox dlg = new MainWindow_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.setVisible(true);
  }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
    else
      super.processWindowEvent(e);
  }

  void Darea_mousePressed(MouseEvent e) {
    command.AddComponent(e.getX(),e.getY(),e);
  }

  void Darea_componentMoved(ComponentEvent e) {

  }

  void jMenuEntity_actionPerformed(ActionEvent e) {
    command.getTopPanel().EntityButton.doClick();
  }

  void jMenuRelationship_actionPerformed(ActionEvent e) {
    command.getTopPanel().RelationButton.doClick();
  }

  void insert_actionPerformed(ActionEvent e) {
    command.getTopPanel().click(((JMenuItem)e.getSource()).getText());
  }

  void jMenuLine_actionPerformed(ActionEvent e) {
    command.getTopPanel().LineButton.doClick();
  }

  /** Edit | Delete */
  void jMenuEditDelete_actionPerformed(ActionEvent e) {
    command.deleteSelectedObjects();
  }

  /** Edit | Select all */
  void jMenuEditSelectAll_actionPerformed(ActionEvent e) {
    command.selectAll();
  }


  void jMenuEditUndo_actionPerformed(ActionEvent e) {
    try {
      command.getUndoManager().undo();
      refreshUndoRedo();
      repaint();
    }
    catch (CannotUndoException error) {
      System.out.println( error.getLocalizedMessage() );
    }
  }

  void jMenuEditRedo_actionPerformed(ActionEvent e) {
    try {
      command.getUndoManager().redo();
      refreshUndoRedo();
      repaint();
    }
    catch (CannotRedoException error) {
      System.out.println( error.getLocalizedMessage() );
    }
  }


  public void keyType(KeyEvent e) {
    command.keyType(e);
  }

  void jMenuHideAllLineSpot_actionPerformed(ActionEvent e) {
    command.hideAllHotSpots();
  }

  // File-->Save test, save drawing file
  // jm: isareamodified viety savedrawing-metodista tnne
  void jMenuSave_actionPerformed(ActionEvent e) {
    if (file == null)
      jMenuSaveAs_actionPerformed(e);
    else
    if (command.isAreaModified()) {
      if (0 > file.getPath().indexOf(".erkka"))
        command.saveDrawingInFile(file.getPath() + ".erkka", true);
      else
        command.saveDrawingInFile(file.getPath(), true);
    }
  }

  void jMenuOpen_actionPerformed(ActionEvent e) {
    // Show dialog box
    if ( command.isAreaModified() ) {
      MessageBox box = new MessageBox( new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          safeFileOpen_actionPerformed(e);
        }
      });
      box.setTitle("Save modified");
      box.addChoice("Yes", 'Y');
      box.addChoice("No", 'N');
      box.addChoice("Cancel", 'C' );
      box.ask("Do you want to save the modified drawing?");
    }
    else
      safeFileOpen_actionPerformed( null );

  }

/**
 *
 * @param evt
 */
  public void safeFileOpen_actionPerformed(ActionEvent evt) {

   if ( evt != null ) {
      String command = evt.getActionCommand();
      // Check if we have unsaved drawing?

      if (command.equals("Yes")) {
         jMenuSave_actionPerformed(null);
      } else if(command.equals("Cancel") || command.equals("Close")) {
        return;
      }
    }
    ExampleFileFilter fil =new ExampleFileFilter("erkka","configuration or image file");

    fc.setFileFilter(fil);
    fc.setVisible(true);
    fc.setDialogTitle("Open...");
    fc.setApproveButtonText("Open");
//    fc.setApproveButtonToolTipText("");
    int returnVal = fc.showOpenDialog(this.contentPane);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        if (command.openDrawingInFile(file)){
          this.setTitle("Erkka - " + file.getPath() );
          Darea.setModified(false);
        }
        else
          this.setTitle("Erkka");
    } else {
//        log.append("Open command cancelled by user." + newline);
    }
    fc.removeChoosableFileFilter(fil);
  }


  void jMenuSaveAs_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil =new ExampleFileFilter("erkka","configuration or image file");
    fc.setFileFilter(fil);

    fc.setVisible(true);
    fc.setDialogTitle("Save as...");
    fc.setApproveButtonText("Save as");
//    fc.setApproveButtonToolTipText("");

    int returnVal = fc.showSaveDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        if(0>file.getPath().indexOf(".erkka"))
          command.saveDrawingInFile(file.getPath()+".erkka", true);
        else
          command.saveDrawingInFile(file.getPath(), true);
      this.setTitle("Erkka - " + file.getPath() );

    }

    fc.removeChoosableFileFilter(fil);
  }

  //NEW
  void jMenuNew_actionPerformed(ActionEvent e) {

    ExampleFileFilter fil =new ExampleFileFilter("erkka","configuration or image file");
    fc.setFileFilter(fil);

    fc.setVisible(true);
    fc.setDialogTitle("Select configuration file...");
    fc.setApproveButtonText("Open configuration");
    fc.setApproveButtonToolTipText("Select configuration file.");
    int returnVal = fc.showOpenDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        command.createNewPicture(file.getPath());
        file = null; // Prevent saving over configuration file
    }
    fc.removeChoosableFileFilter(fil);
  }


  //infopanel Color
  void jMenuColorInfo_actionPerformed(ActionEvent e) {
    Color col = JColorChooser.showDialog(this, "Infopanel", Color.blue);
    if (col != null)
      command.setInfoPanelColor(col);
  }

  //drawingarea color
  void jMenuBackground_actionPerformed(ActionEvent e) {
    Color col = JColorChooser.showDialog(this, "Drawing area", Color.blue);
    if (col != null)
      command.setDrawingAreaColor(col);

  }

  //line color
  void jMenuColorLine_actionPerformed(ActionEvent e) {
    Color col = JColorChooser.showDialog(this, "Drawing area", Color.blue);
    if (col != null)
      command.setLineColor(col);
  }


  //Printing
  void jMenuPrint_actionPerformed(ActionEvent e) {
    command.print();
  }
//Export
  void jMenuExport_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil =new ExampleFileFilter("png","PNG file");
    JFileChooser fc = new JFileChooser();
    fc.setFileFilter(fil);
    fc.setVisible(true);
    fc.setDialogTitle("Export drawing... ");
    fc.setApproveButtonText("Export");
//    fc.setApproveButtonToolTipText("");

    int returnVal = fc.showOpenDialog(this.contentPane);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        if (0 > file.getPath().indexOf(".png"))
          command.export(file.getPath() + ".png", Darea);
        else
          command.export(file.getPath(), Darea);
    } else {
//        log.append("Open command cancelled by user." + newline);
    }

  }


//Selected
  void jMenuColorSelected_actionPerformed(ActionEvent e) {
    Color col = JColorChooser.showDialog(this, "Drawing area", Color.blue);
    if (col != null)
      command.setSelectedColor(col);

  }

  //Close
  void jMenuClose_actionPerformed(ActionEvent e) {
    if ( Darea.getModified() ) {
      MessageBox box = new MessageBox( new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          safeFileClose_actionPerformed(e);
        }
      });
      box.setTitle("Closing...");
      box.addChoice("Yes", 'Y');
      box.addChoice("No", 'N');
      box.addChoice("Cancel", 'C' );
      box.ask("Do you want to save the modified drawing?");
    }
    else
      safeFileClose_actionPerformed( null );

  }

  public void safeFileClose_actionPerformed(ActionEvent evt) {
    if ( evt != null ) {
      String command = evt.getActionCommand();
      // Check if we have unsaved drawing?

      if (command.equals("Yes")) {
         jMenuSave_actionPerformed(null);
      } else if(command.equals("Cancel") || command.equals("Close")) {
        return;
      }
    }
    command.clearDrawingArea();
    command.clearVariables();
    this.setTitle("Erkka");
  }

  void jMenuRelation_actionPerformed(ActionEvent e) {
    tabPane.setSelectedComponent( relationPanel );
  }

  void jMenuDrawing_actionPerformed(ActionEvent e) {
    tabPane.setSelectedComponent( drawingPanel );
  }


  void jMenuQuery_actionPerformed(ActionEvent e) {
    tabPane.setSelectedComponent( queryPanel);
  }


 /**
  * This method is called after each undoable operation
  * in order to refresh the presentation state of the
  * undo/redo GUI
  */
  public void refreshUndoRedo() {
    UndoManager undoManager_;

    undoManager_ = command.getUndoManager();
     // refresh undo
    jMenuUndo.setText( undoManager_.getUndoPresentationName() );
    jMenuUndo.setEnabled( undoManager_.canUndo() );

     // refresh redo
    jMenuRedo.setText( undoManager_.getRedoPresentationName() );
    jMenuRedo.setEnabled( undoManager_.canRedo() );
  }


  /**
  * An undo/redo adpater. The adpater is notified when
  * an undo edit occur(e.g. add or remove from the list)
  * The adptor extract the edit from the event, add it
  * to the UndoManager, and refresh the GUI
  */

  private class UndoAdapter implements UndoableEditListener {
     public void undoableEditHappened (UndoableEditEvent evt) {
     	UndoableEdit edit = evt.getEdit();
     	command.getUndoManager().addEdit( edit );
     	refreshUndoRedo();
     }
  }

  void jMenuAbout_actionPerformed(ActionEvent e) {
    about.setBounds(getX()+100,getY()+100,about.getWidth(),about.getHeight());
    about.show();
  }


  void jMenuEntity1_actionPerformed(ActionEvent e) {

  }
  void jMenuExit1_actionPerformed(ActionEvent e) {

  }
  void jMenuLine1_actionPerformed(ActionEvent e) {

  }

  void jMenuRedo1_actionPerformed(ActionEvent e) {

  }
  void jMenuUndo1_actionPerformed(ActionEvent e) {

  }
  void jMenuAbout1_actionPerformed(ActionEvent e) {
    MainWindow_AboutBox dlg = new MainWindow_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();

  }

  void jMenuRelationship1_actionPerformed(ActionEvent e) {

  }
  void jMenuAttribute1_actionPerformed(ActionEvent e) {

  }
  void jMenuDelete2_actionPerformed(ActionEvent e) {

  }
  void jMenuRedo2_actionPerformed(ActionEvent e) {

  }
  void jMenuExit2_actionPerformed(ActionEvent e) {

  }
  void jMenuSelectAll2_actionPerformed(ActionEvent e) {
    if (sqlText.getCaret().isSelectionVisible()) {
      sqlText.selectAll();
    }
    if (resultText.getCaret().isSelectionVisible()) {
      resultText.selectAll();
    }
  }

  void jMenuUndo2_actionPerformed(ActionEvent e) {

  }
  void jMenuPrint2_actionPerformed(ActionEvent e) {
//    PrintUtilities.printComponent( relationPanel.getDrawingArea() );
    JComponentVista vista = new JComponentVista(relationPanel.getDrawingArea(), new PageFormat());
    PrinterJob pj = PrinterJob.getPrinterJob();
    pj.setPageable(vista);
    try {
      if (pj.printDialog()) {
        pj.print();
      }
    } catch (PrinterException er) {
      System.out.println(er);
    }
  }

  void jMenuAbout2_actionPerformed(ActionEvent e) {
    MainWindow_AboutBox dlg = new MainWindow_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();

  }
  void jMenuExport2_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil =new ExampleFileFilter("png","PNG file");
    JFileChooser fc = new JFileChooser();
    fc.setFileFilter(fil);
    fc.setVisible(true);
    fc.setDialogTitle("Export relation... ");
    fc.setApproveButtonText("Export");
//    fc.setApproveButtonToolTipText("");


    int returnVal = fc.showOpenDialog(this.contentPane);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        //relationPanel.export(file.getPath());
        File f;
        if(0>file.getPath().indexOf(".png"))
         f = new File(file.getPath()+".png");
        else f= new File(file.getPath());


        command.export(f.getPath(), relationPanel.getDrawingArea());
    } else {

    }

  }
// help open
  void jMenuManual_actionPerformed(ActionEvent e) {
    helpFrame.setVisible(true);
    helpviewer.setEditable(false);
 //   helpviewer.addHyperlinkListener(new HyperlinkListener);
    try{
    helpviewer.setPage(erkka.MainWindow.class.getResource("drawing.html"));
    }
    catch(Exception ex){ex.printStackTrace();};


  }
  // Refresh


  void jMenuItem1_actionPerformed(ActionEvent e) {
    command.editSelected();
  }

/*
  void jMenuRefreshRel_actionPerformed(ActionEvent e) {

  }

  void jMenuRefreshSQL_actionPerformed(ActionEvent e) {

  }
*/
  void jMenuManual1_actionPerformed(ActionEvent e) {
    helpFrame.setVisible(true);
    helpviewer.setEditable(false);
 //   helpviewer.addHyperlinkListener(new HyperlinkListener);
    try{
   helpviewer.setPage(erkka.MainWindow.class.getResource("SQL.html"));

    }
    catch(Exception ex){ex.printStackTrace();};



  }

  void jMenuManual2_actionPerformed(ActionEvent e) {

  helpFrame.setVisible(true);
    helpviewer.setEditable(false);
 //   helpviewer.setContentType("text/html");
 //   helpviewer.addHyperlinkListener(new HyperlinkListener);
    try{
    //helpviewer.sets
    helpviewer.setPage(erkka.MainWindow.class.getResource("relations.html"));
//helpviewer.setPage("file://localhost/c:/mytemp/valmis_erkka/Erkka/directions.html");
    }
    catch(Exception ex){ex.printStackTrace();};


  }

  void helpviewer_hyperlinkUpdate(HyperlinkEvent e) {
     if(e.getEventType()== HyperlinkEvent.EventType.ACTIVATED){

       try {
       //  String debug=e.getURL();
         helpviewer.setPage(e.getURL());
 //        helpviewer.scrollRectToVisible();
       } catch (Throwable t) {
              t.printStackTrace();
      }
    }
  }
  void sqlArea1_keyPressed(KeyEvent e) {

  }
  void sqlArea1_keyReleased(KeyEvent e) {

  }
  void sqlArea1_keyTyped(KeyEvent e) {

  }

  // onko sql-kyselyn tekemisess tullut virheit
  private boolean isSQLError() {
    if (sqlText.getText().length() < 1)
      return true;
    if (resultText.getText().length() >= 6)
      if (resultText.getText().substring(0,6).equals("Error."))
        return true;
    return false;
  }




  void jMenuSql2_actionPerformed(ActionEvent e) {

  }
  void jMenuRelation2_actionPerformed(ActionEvent e) {

  }
  void jMenuQuery2_actionPerformed(ActionEvent e) {

  }
  void jMenuSql3_actionPerformed(ActionEvent e) {

  }
  void jMenuRelation3_actionPerformed(ActionEvent e) {

  }
  void jMenuAbout3_actionPerformed(ActionEvent e) {

  }
  void jMenuExit3_actionPerformed(ActionEvent e) {

  }
  void jMenuCopy2_actionPerformed(ActionEvent e) {
    if (sqlText.getSelectedText() != null) {
      sqlText.copy();
    }
    if (resultText.getSelectedText() != null) {
      resultText.copy();
    }
  }
  void jMenuCut2_actionPerformed(ActionEvent e) {
    if (sqlText.getSelectedText() != null) {
      sqlText.cut();
    }
    if (resultText.getSelectedText() != null) {
      resultText.cut();
    }
  }

  void jMenuPaste2_actionPerformed(ActionEvent e) {

    if (sqlText.getCaret().isSelectionVisible()) {
      sqlText.paste();
    }
    if (resultText.getCaret().isSelectionVisible()) {
      resultText.paste();
    }

  }

  void jMenuQuery3_actionPerformed(ActionEvent e) {

  }
  void jMenuDrawing3_actionPerformed(ActionEvent e) {

  }

  /**
   * @todo Tarkistetaan onko piirros muuttunut ja sitten tarvittaessa tehdn sql-muunnos
   *       Huomaa, ett on odotettava command.makesql:n suoriutumista.
   * @param e ActionEvent
   */
  void jMenuUpdateRelation_actionPerformed(ActionEvent e) {
    Writer w = null;
    BufferedWriter b = null;
    try{
      //if (isSQLError())
      //  command.makesql(sqlArea);
      //else {
        w = new FileWriter("tulos.sql");
        b= new BufferedWriter(w);
        b.write(sqlText.getText());
        b.flush();
      //}
      relationPanel.drawRelation("tulos.sql");
      relationPanel.repaint();
      relationPanel.revalidate();
    } catch(Exception ex) {
        MessageBox m = new MessageBox();
        m.setTitle("Error saving SQL file");
        m.askOkay(ex.getLocalizedMessage());
      }
    finally {
      try{
        if (b != null) b.close();
      } catch(Exception ex){
          MessageBox m = new MessageBox();
          m.setTitle("Error saving SQL file");
          m.askOkay(ex.getLocalizedMessage());
        }
    }
  }
  void jMenuSql1_actionPerformed(ActionEvent e) {

  }
  void jMenuRelation1_actionPerformed(ActionEvent e) {

  }
  void jMenuQuery1_actionPerformed(ActionEvent e) {

  }


  void executeButton_actionPerformed(ActionEvent e) {
    executeSQL();
  }

  void executeSQL() {
    if (query != null && query.isConnected()) {
        String result = "";
        try {
          result = query.executeQueryBatch(sqlText.getText());

            resultText.setTabSize(query.getDisplaySize() + 2);
          resultText.setText(result);
        }
        catch (Exception exp) {
          MessageBox msg = new MessageBox();
          msg.setTitle("Execute failed.");
          msg.askOkay(exp.getMessage());
        }
      }
    else {
      MessageBox msg = new MessageBox();
      msg.setTitle("Execute failed.");
      msg.askOkay("Open or connect to database before executing SQL.");
    }

  }

  /**
   * @todo   nmkin savet olisi voinut tehd yhteeen metodiin
   */
  void jMenuSaveAs2_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil =new ExampleFileFilter("sql","SQL text file");
    JFileChooser fc = new JFileChooser();
    fc.resetChoosableFileFilters();
    fc.setFileFilter(fil);

    fc.setVisible(true);
    fc.setDialogTitle("Save SQL as...");
    fc.setApproveButtonText("Save as");

    int returnVal = fc.showSaveDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        File f;
        if(0>file.getPath().indexOf(".sql"))
         f = new File(file.getPath()+".sql");
        else f= new File(file.getPath());
         Writer w=null;
         BufferedWriter b= null;
         try{
          w= new FileWriter(f.getPath());
          b= new BufferedWriter(w);
          Date da =new Date(System.currentTimeMillis());
          b.write("-- SQL saved by Erkka 1.2 in "+da.toString() + "\n");
          b.write(sqlText.getText());
          b.flush();
          } catch(Exception ex) {
              MessageBox m = new MessageBox();
              m.setTitle("Error saving SQL file");
              m.askOkay(ex.getLocalizedMessage());
            }
          finally {
            try{
              if (b != null) b.close();
            } catch(Exception ex){
                MessageBox m = new MessageBox();
                m.setTitle("Error saving SQL file");
                m.askOkay(ex.getLocalizedMessage());
              }
          }

    }

    fc.removeChoosableFileFilter(fil);
  }

  void jMenuSaveAs3_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil =new ExampleFileFilter("txt","Text file");
   // fc.resetChoosableFileFilters();
    JFileChooser fc = new JFileChooser();
    fc.setSelectedFile(null);
    fc.setFileFilter(fil);

    fc.setVisible(true);
    fc.setDialogTitle("Save Results as...");
    fc.setApproveButtonText("Save as");

    int returnVal = fc.showSaveDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        file = fc.getSelectedFile();
        //this is where a real application would open the file.
        File f;
        if(0>file.getPath().indexOf(".txt"))
         f = new File(file.getPath()+".txt");
        else f= new File(file.getPath());
         Writer w=null;
         BufferedWriter b= null;
         try{
          w= new FileWriter(f.getPath());
          b= new BufferedWriter(w);
          b.write(resultText.getText());
          b.flush();
          } catch(Exception ex) {
              MessageBox m = new MessageBox();
              m.setTitle("Error saving text file");
              m.askOkay(ex.getLocalizedMessage());
            }
          finally {
            try{
              if (b != null) b.close();
            } catch(Exception ex){
                MessageBox m = new MessageBox();
                m.setTitle("Error saving text file");
                m.askOkay(ex.getLocalizedMessage());
              }
          }

    }

    fc.removeChoosableFileFilter(fil);
  }

  void jMenuPrint3_actionPerformed(ActionEvent e) {
    int tabsize = resultText.getTabSize();
    Properties props = new Properties();
    PrintJob pjob = getToolkit().getPrintJob(this,"Print SQL & results", props);
    if (pjob != null) {
      /*
           int INCH = 72;
           double LETTER_WIDTH = 8.5 * INCH;
           double LETTER_HEIGHT = 11 * INCH;

           Paper paper = new Paper();
           int margin = INCH/6;
           double pageWidth = LETTER_WIDTH - 2 * margin;
           double pageHeigth = LETTER_HEIGHT - 2 * margin;
           paper.setImageableArea(margin, margin, pageWidth, pageHeigth) ;
           pjob.getPageDimension().setSize() ;
           format.setPaper(paper);
     */

      Graphics pg = pjob.getGraphics();
      if (pg != null) {
        String s = "\n\n" + sqlText.getText() + "\n\n" + resultText.getText();

        int pageNum = 1;
        int linesForThisPage = 0;
        int linesForThisJob = 0;
        StringReader sr = new StringReader (s);
        LineNumberReader lnr = new LineNumberReader(sr);
        String nextLine = "";
        int pageHeight = pjob.getPageDimension().height;
         Font fnt = new Font("Courier New", Font.PLAIN, 8);
         //have to set the font to get any output
         pg.setFont (fnt);
         FontMetrics fm = pg.getFontMetrics(fnt);
         int fontHeight = fm.getHeight();
         int fontDescent = fm.getDescent();
         int curHeight = 0;
           do {
             try {
               nextLine = lnr.readLine();
               if (nextLine != null) {
                  // tabs
                  if (nextLine.indexOf('\t') >= 0)
                    nextLine = convertTabsToSpaces(nextLine, tabsize);
                  // margin (not very good idea)
                  nextLine = "   " + nextLine;
                  if ( (curHeight + fontHeight) > pageHeight) {
                   // new Page
                   pageNum++;
                   linesForThisPage = 0;
                   pg.dispose();
                   pg = pjob.getGraphics();
                   if (pg != null) {
                     pg.setFont(fnt);
                   }
                   curHeight = 0;
                 }
                 curHeight += fontHeight;
                 if (pg != null) {
                   pg.drawString(nextLine, 0, curHeight - fontDescent);
                   linesForThisPage++;
                   linesForThisJob++;
                 }
               }
             } catch (IOException exp) {
               MessageBox msg = new MessageBox();
               msg.setTitle("Printing failed.");
               msg.askOkay("Could not read text.");
             }

           } while (nextLine != null);


        pg.dispose();
      }
      pjob.end();
    }

  }

  private String convertTabsToSpaces(String s, int tabsize) {
    String[] palat = s.split("\t");
    StringBuffer buff = new StringBuffer("");
    for (int i=0;i<palat.length;i++) {
      buff.append(palat[i]);
      addSpace(buff, tabsize-palat[i].length());
    }
    return buff.toString();
  }

  private void addSpace(StringBuffer b, int amount) {
    for (int i=0;i<amount;i++)
      b.append(' ');
  }
  void jMenuDrawing2_actionPerformed(ActionEvent e) {

  }


  void jMenuTransform_actionPerformed(ActionEvent e) {
    updateSQL();
  }

  void updateSQL() {
    resultText.setText("");
    StringBuffer tulos = new StringBuffer("");
    try {
      command.setSQLTransformFinishedListener(

          new javax.swing.event.ChangeListener() {

        public void stateChanged(ChangeEvent e) {
          if (e.getSource() instanceof LongTask) {
            if ( ( (LongTask) e.getSource()).getResults().length() < 6) {
              resultText.setText("Error. SQL-transformation produced nothing. Fix the error and select Refresh SQL (F5).\n\nER-diagram is most likely empty.");
            } else {
              sqlText.setText( ( (LongTask) e.getSource()).getResults());
              resultText.setText("SQL-transformation completed successfully.");
            }
          }
        }

      }

      );
      command.makesql();

    } catch (Exception e) {
      resultText.setText("Error. SQL-transformation could not be completed. Fix the error and select Refresh SQL (F5).\n\n" + e.getMessage());
    }

  }

  void jMenuConnectDB_actionPerformed(ActionEvent e) {
    dlg = new MainWindow_ConnectODBC(this, "Connect to database", true);
    dlg.databaseText.addKeyListener(
        new KeyAdapter() {
          public void keyPressed(KeyEvent e) {
            if (e.getKeyCode() == e.VK_ENTER) {
              dlg.Connect_actionPerformed(null);
            }
          }
        }
    );
    dlg.userText.addKeyListener(
        new KeyAdapter() {
          public void keyPressed(KeyEvent e) {
            if (e.getKeyCode() == e.VK_ENTER) {
              dlg.Connect_actionPerformed(null);
            }
          }
        }
    );
    dlg.passText.addKeyListener(
        new KeyAdapter() {
          public void keyPressed(KeyEvent e) {
            if (e.getKeyCode() == e.VK_ENTER) {
              dlg.Connect_actionPerformed(null);
            }
          }
        }
    );
    dlg.addWindowListener(
      new WindowAdapter() {
        public void windowOpened(WindowEvent e) {
          dlg.databaseText.requestFocus();
        }
        public void windowClosed(WindowEvent e) {
          if (dlg != null) {
            if (e.getSource() == dlg) {
              ODBCQuery tempquery = dlg.getQuery();
              if (tempquery != null) {
                query = tempquery;
                if (query.isConnected()) {
                  connectionInfoButton.setBorder(BorderFactory.
                                                 createRaisedBevelBorder());
                  connectionInfoButton.setText("Connected");
                  executeButton.setEnabled(true);
                } else {
                  connectionInfoButton.setBorder(BorderFactory.
                                                 createLoweredBevelBorder());
                  connectionInfoButton.setText("Not connected");
                  executeButton.setEnabled(false);
                }
              }
            }
          }
        }
      }
    );
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setVisible(true);

  }

  void jMenuExecute_actionPerformed(ActionEvent e) {
    executeSQL();
  }

  void jMenuOpenDB_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil2 = new ExampleFileFilter("odb","OpenOffice 2.0 Database");
    JFileChooser fc = new JFileChooser();
    fc.addChoosableFileFilter(fil2);
    ExampleFileFilter fil1 =new ExampleFileFilter("mdb","Microsoft Access Database");
    fc.addChoosableFileFilter(fil1);

    fc.setAcceptAllFileFilterUsed(false);
    fc.setVisible(true);
    fc.setDialogTitle("Open database file...");
    fc.setApproveButtonText("Open");
    fc.setApproveButtonToolTipText("Open database for queries.");
    int returnVal = fc.showOpenDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File db = fc.getSelectedFile();
        String dbpath = db.getAbsolutePath();
        jMenuDisconnectDB_actionPerformed(e);
        query = new ODBCQuery(dbpath, fil1.getExtension(db));
        try {
          query.connect();
          connectionInfoButton.setBorder(BorderFactory.createRaisedBevelBorder());
          connectionInfoButton.setText("Connected");
          executeButton.setEnabled(true);
        } catch (Exception exc) {
          MessageBox msg = new MessageBox();
          msg.setTitle("Connect error.");
          msg.askOkay(exc.getMessage());
        }
        //this is where a real application would open the file.
        //command.createNewPicture(file.getPath());
        //file = null; // Prevent saving over configuration file
    }
    fc.removeChoosableFileFilter(fil1);
    fc.removeChoosableFileFilter(fil2);

  }

  void jMenuDisconnectDB_actionPerformed(ActionEvent e) {
    if (query != null) {
      if (query.isConnected()) {
        try {
          query.disconnect();
          connectionInfoButton.setBorder(BorderFactory.createLoweredBevelBorder());
          connectionInfoButton.setText("Not connected");
          executeButton.setEnabled(false);
        } catch (Exception exp) {
          MessageBox msg = new MessageBox();
          msg.setTitle("Disconnect failed.");
          msg.askOkay(exp.getMessage());
        }
      }
    }
  }


  void jMenuOpenSQL_actionPerformed(ActionEvent e) {
    ExampleFileFilter fil = new ExampleFileFilter("sql","SQL text file");
    JFileChooser fc = new JFileChooser();
    fc.resetChoosableFileFilters();
    fc.setFileFilter(fil);


    fc.setAcceptAllFileFilterUsed(false);
    fc.setVisible(true);
    fc.setDialogTitle("Open SQL text file...");
    fc.setApproveButtonText("Open");
    fc.setApproveButtonToolTipText("Insert SQL text file to statement-area.");
    int returnVal = fc.showOpenDialog(this.contentPane);

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File db = fc.getSelectedFile();
        String dbpath = db.getAbsolutePath();
        try {
          BufferedReader r = new BufferedReader(new FileReader(db));
          sqlText.setText("");
          String line = null;
          while ((line = r.readLine()) != null) {
            sqlText.append(line + "\n");
          }
        } catch (Exception exc) {
          MessageBox msg = new MessageBox();
          msg.setTitle("Error reading file.");
          msg.askOkay(exc.getMessage());
        }
    }
    fc.removeChoosableFileFilter(fil);

  }

  void jMenuClear_actionPerformed(ActionEvent e) {
    sqlText.setText("");
  }



}




