package erkka;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Title:        Erkka-Projekti
 * Description: About box.
 * Copyright:    Copyright (c) 2002
 * Company:      Erkka
 * @author Juho Yli-Honkola
 * @version 1.2 Jukka Mntyl 2005. Updated text.
 */

public class MainWindow_AboutBox extends JDialog implements ActionListener {

  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JPanel insetsPanel1 = new JPanel();
  JPanel insetsPanel2 = new JPanel();
  JPanel insetsPanel3 = new JPanel();
  JButton button1 = new JButton();
  JLabel imageLabel = new JLabel();
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  JLabel label3 = new JLabel();
  JLabel label4 = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  GridLayout gridLayout1 = new GridLayout();
  String product = "Erkka-projekti";
  String version = "1.23";
  String copyright = "Copyright (c) 2005";
  String comments = "";
  JLabel jLabel1 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  public MainWindow_AboutBox(Frame parent) {
    super(parent);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    pack();
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //imageLabel.setIcon(new ImageIcon(MainWindow_AboutBox.class.getResource("[Your Image]")));
    this.setTitle("About");
    setResizable(false);
    panel1.setLayout(borderLayout1);
    panel2.setLayout(borderLayout2);
    insetsPanel1.setLayout(gridBagLayout1);
    insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    gridLayout1.setRows(4);
    gridLayout1.setColumns(1);
    label1.setText("Erkka-Project                 ");
    label2.setText("1.23 (build date 22.2.2006)");
    label3.setText("Copyright (c) 2002 - 2006");
    label4.setFont(new java.awt.Font("Dialog", 1, 12));
    label4.setText(comments);
    insetsPanel3.setLayout(gridLayout1);
    insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
    button1.setText("Ok");
    button1.addActionListener(this);
    jLabel1.setText("jLabel1");
    jLabel3.setText("Hanna-Leena Peltomaa");
    jLabel4.setText("Antti Enqvist");
    jLabel4.setVerticalAlignment(SwingConstants.TOP);
    jLabel5.setText("Tommi Grenfors");
    jLabel5.setVerticalAlignment(SwingConstants.TOP);
    jLabel2.setText("Juho Yli-Honkola");
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel6.setText("University of Jyvskyl ");
    jLabel7.setFont(new java.awt.Font("Dialog", 0, 9));
    jLabel7.setText("http://www.it.jyu.fi");
    jLabel8.setFont(new java.awt.Font("Dialog", 0, 9));
    jLabel8.setText("Software project");
    jLabel9.setText("Jukka Mntyl (further development)");
    insetsPanel2.add(imageLabel, null);
    panel2.add(insetsPanel2, BorderLayout.CENTER);
    this.getContentPane().add(panel1, null);
    insetsPanel3.add(label1, null);
    insetsPanel3.add(label2, null);
    insetsPanel3.add(label3, null);
    insetsPanel3.add(label4, null);
    panel1.add(insetsPanel1, BorderLayout.CENTER);
    insetsPanel1.add(jLabel4,                    new GridBagConstraints(0, 1, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 52), 94, 0));
    insetsPanel1.add(jLabel5,                      new GridBagConstraints(0, 2, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 15), 116, 0));
    insetsPanel1.add(jLabel3,                      new GridBagConstraints(0, 3, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 12), 84, 0));
    insetsPanel1.add(jLabel2,               new GridBagConstraints(0, 4, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 129, 0));
    insetsPanel1.add(jLabel6,                              new GridBagConstraints(0, 5, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 1, 0), 7, 21));
    insetsPanel1.add(jLabel8,                    new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 104, 4));
    insetsPanel1.add(jLabel7,                            new GridBagConstraints(0, 6, 1, 1, 5.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 120, 10));
    insetsPanel1.add(button1,                        new GridBagConstraints(0, 12, 1, 3, 0.0, 0.0
            ,GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(7, 0, 21, 0), 17, 2));
    insetsPanel1.add(jLabel9,          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 28, 0));
    panel2.add(insetsPanel3,  BorderLayout.WEST);
    panel1.add(panel2, BorderLayout.NORTH);
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }
  /**Close the dialog*/
  void cancel() {
    dispose();
  }
  /**Close the dialog on a button event*/
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button1) {
      cancel();
    }
  }
}
