package erkka;

import java.lang.String;
/**
 * <p>Title:</p>
 * <p>Description: Reference is allways owned by table. It knows
 *              whice attribute owns it in own table and then
 *              the table and its attribute, whice line is connected to.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Jyvskyl</p>
 * @author HLP
 * @version 1.0
 */

public class Reference {
  /**Attribute of the table who owns the line*/
  private String target1Attribute;
  /**Name of the table to whice table has reference */
  private String tableTarget2;
  /**Attribute of the table whice are referenced to */
  private String target2Attribute;
  /**Cascades of the line */
  private String cascade;

  /**constructor creates new Reference*/
  public Reference() {
  }
  /**@return target1Attribute */
  public String getTarget1Attribute() {
    return target1Attribute;
  }
  /**@return tableTarget2 */
  public String getTableTarget2() {
    return tableTarget2;
  }
  /**@return target2Attribute */
  public String getTarget2Attribute() {
    return target2Attribute;
  }
  /**@return cascade */
  public String getCascade() {
    return cascade;
  }

  /**
   * Set line between tables
   * @param attributeM String
   * @param tableName String
   * @param attribute1 String
   */
  public void setAttributes(String attributeM, String tableName, String attribute1) {
    /**Attribute of the table who owns the line*/
    target1Attribute = attributeM;
    /**Name of the table to whice table has reference */
    tableTarget2 = tableName;
    /**Attribute of the table whice are referenced to */
    target2Attribute = attribute1;
  }

  /**
   * find all information about references
   * @param line begins with foreignkeys name
   */
  public void findInformation(String line) {
    String temp = line;

    String wordReference = "REFERENCES";
    int indexReference = line.indexOf(wordReference);
    int firstBracket = line.indexOf("(");
    int endBracket = line.indexOf(")");
    target1Attribute = temp.substring(firstBracket+1,endBracket);//remove brackets

    indexReference = temp.indexOf(wordReference);
    temp = temp.substring(indexReference+wordReference.length()+1);
    int index = temp.indexOf(" ");
    tableTarget2 = temp.substring(0,index);

    firstBracket = temp.indexOf("(");
    endBracket = temp.indexOf(")");
    target2Attribute = temp.substring(firstBracket+1,endBracket);//remove brackets
    cascade = temp.substring(endBracket+1);
  }
}
