package erkka;


import java.awt.event.*;
import java.awt.Color;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.awt.image.*;


import javax.swing.JComponent;

/**
 * <p>Title: </p>
 * <p>Description: The class controls mousemoves.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author HLP
 * @version 1.0
 */

public class RelationControl {

  private DrawingArea area;
  private BaseObject temp_obj;
  private Symbol foo;
  private int mousepX;
  private int mousepY;
  private Hashtable box_coordinates = new Hashtable();

  private BaseObject temp;//,DraggedObject;
  private Line temp2;  // temp line

  public RelationControl(DrawingArea area, Hashtable box_coordinates) {
    this.box_coordinates = box_coordinates;
    this.area = area;
  }

  public  void setListeners(BaseObject newSymbol){
    newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mousePressed(MouseEvent e) {
        obj_mousePressed(e);
     }
      });

      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        obj_mouseReleased(e);
        }
      });

      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseExited(MouseEvent e) {
        obj_mouseExited(e);
        }
      });

      newSymbol.addMouseMotionListener(new java.awt.event.MouseMotionListener(){
      public void mouseDragged(MouseEvent e) {
        obj_mouseDragged(e);
        }
      public void mouseMoved(MouseEvent e){}
      });
  }

  public void obj_mousePressed(MouseEvent e){

    mousepX=e.getX(); mousepY=e.getY();
    temp=((BaseObject)e.getComponent());
    area.setFocusVectorNull();
    temp.SetObjectFocus(true);
    area.repaint();
  }

  public void obj_mouseDragged(MouseEvent e){
    if ((((BaseObject)e.getComponent()).getObjectFocus()) == true){

      int mx = e.getX()-mousepX;
      int my = e.getY()-mousepY;

      int dx = area.getFocusTableLeft()+mx;
      int dy = area.getFocusTableTop()+my;

      if ( dx < 0 ) {
        mx = -area.getFocusTableLeft();
        dx = -mx;
      }

      if ( dy < 0 ) {
        my = -area.getFocusTableTop();
        dy = -my;
      }


      if (  dx > 0 || dy > 0){
        for (int i=0;i<area.getFocusVectorSize();i++){
          int x = area.getObject(i).getX()+mx;
          int y = area.getObject(i).getY()+my;
          area.getObject(i).setBounds(x,y,area.getObject(i).getWidth(),area.getObject(i).getHeight());
        }
        area.setPreferredSize( new Dimension(Math.max(area.getFocusTableRight(), area.getWidth()),
                                              Math.max(area.getFocusTableBottom(), area.getHeight() )));
        area.revalidate();
       } // if
    }
    area.repaint();
  }

  public void obj_mouseReleased(MouseEvent e) {
    area.repaint();
    RelationBox b = (RelationBox)e.getSource();
    box_coordinates.put(b.getName(), new Point(b.getX(), b.getY()));
  }

  public void obj_mouseExited(MouseEvent e){
    area.repaint();
  }

}