package erkka;

import javax.swing.*;
import java.awt.Panel;
import java.util.*;
import java.io.*;
/**
 * <p>Title: SQL-parser</p>
 * <p>Description: the program reads SQL-file and finds all necessary
 *              information about it by inserting them to datastructure.
 *              Relations has the list about all relations.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:University of Jyvskyl</p>
 * @author HLP
 * @version 1.0
 */

public class Relations {
  /**createTables has all of tables as Hastable*/
  Hashtable createTables = new Hashtable();
//  JPanel jpanel = new JPanel();

  /**constructor creates new Relations*/
  public Relations() {
  }
  InputStream in = null;
  Reader reader = null;
  BufferedReader breader = null;
/**
 * @return createTables as Hastable
 */
  public Hashtable getCreateTables() {return createTables;}

/**
 * <p>This method read the file and allways when <code>CREATE TABLE</code> exist
 * is invited the function, whice search all information of this relation.
 * All relations are added to vector createTables.</p>
 */
  public void readFile(String fileName) {
    try {
      in = new FileInputStream(fileName);
      reader = new InputStreamReader(in,"UTF-8");
      breader = new BufferedReader(reader);
      String line = null;
      String word = "CREATE TABLE";
      int index;
      while ( (line=breader.readLine())!= null) {
        index = line.indexOf(word);
        while (index != -1) { // when CREATE TABLE is founded
          line = line.substring(index+word.length());
          Relation relation = new Relation();
          try {
            relation.createTable(breader,line);
          } catch (Exception e) {
            MessageBox m = new MessageBox();
            m.setTitle("Error creating a relation");
            m.askOkay(e.getLocalizedMessage());
          }
          createTables.put( relation.getTableName(), relation );
          index = line.indexOf(word);
        }
      }
    } catch ( IOException ioe ) {
      ioe.printStackTrace();
    } finally {
      try {
        if (breader != null) breader.close();
      } catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }
  }
}
