package erkka;

import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

/**
 * Title:        Erkka-Projekti
 * Description:  Super class of the boxes, diamond and cicles. Override paint
 * method to generate new symbols.
 * Copyright:    Copyright (c) 2002
 * Company:      Erkka
 * @author Antti Enqvist & Juho Yli-Honkola
 * @version 1.0
 */

public class Symbol extends BaseObject{

/**
* object name
*/
  String Obj_name;

  private Vector AllLines = new Vector();   // ???
  protected Graphics2D g2;

/**
* defaul constructor sets. Symbol contais four hotspot and those are defined here
*/
  public Symbol() {
    hotspots.SetSpotToTable(new HotSpot(getX() + (getWidth()/2), getY()));
    hotspots.SetSpotToTable(new HotSpot(getX() + getWidth(), getY() + getHeight()/2));
    hotspots.SetSpotToTable(new HotSpot(getX() + getWidth()/2, getY() + getHeight()));
    hotspots.SetSpotToTable(new HotSpot(getX(), getY() + getHeight()/2));
  }

/**
* sets object name
*@param O_name desired name
*/
  public void SetObjName(String O_name){
    this.Obj_name = O_name;
  }

/**
* return object name
*/
  public String GetObjName(){return Obj_name;}



/**
* sets own hotspots
*/
  public void SetOwnSpots(){
    // first line : top center 2: right center 3: down center 4:left center
    hotspots.GetSpotFromTable(0).setBounds((getX() + getWidth()/2), getY(),1,1);
    hotspots.GetSpotFromTable(1).setBounds(getX() + getWidth(), getY() + getHeight()/2,1,1);
    hotspots.GetSpotFromTable(2).setBounds(getX() + getWidth()/2, getY() + getHeight(),1,1);
    hotspots.GetSpotFromTable(3).setBounds(getX(), getY() + getHeight()/2,1,1);
  }

/**
* this functon returns nearest hotspot
*/
  public HotSpot GetNearest(Point foo){
    return ((HotSpot)hotspots.GetNearestHotSpot(foo));
  }

/**
* add line to vector
*/
  public void AddLine(Component line)
  {
    AllLines.add(line);
  }

/**
* Invokes when mouse is pressed.
*/
  public void  mousePressed(MouseEvent e){
    if (this.obj_focus == false)
      setCursor( Cursor.getPredefinedCursor(Cursor.MOVE_CURSOR));
//  this.SetOwnSpots();
  }

/**
* Invokes when mouse button is released
*/
  public void mouseReleased(MouseEvent e) {
      setCursor( Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
//      this.SetOwnSpots();

  }
/**
* Invokes when component is moved. This function also calls SetOwnSpots to set
* hotspots new place
*/
  public void ComponentMoved(ComponentEvent e){this.SetOwnSpots();}

  public void ComponentResized(ComponentEvent e){this.SetOwnSpots();}
  /**
   * This function handles mouseClicked event of interface MouseListener.
   * Function is not implemented...
   */
  public void mouseClicked(MouseEvent e) {
  }

  /**
   * This function handles mouseEntered event of interface MouseListener.
   * This is the right place for changing the mouse cursor for example
   * as a doubleheaded arrow.
   */
  public void mouseEntered(MouseEvent e) {
  }

  /**
   * This function handles mouseExited event of interface MouseListener.
   * This is the right place for changing the mouse cursor back as normal if
   * it was changed in method mouseEntered()
   */
  public void mouseExited(MouseEvent e) {
  }

  /**
   * This function handles mouseMoved event of interface MouseMotionListener.
   * Not implemented.
   */
  public void mouseMoved(MouseEvent e){
  }

  /**
   * This function handles mouseDragged event of interface MouseMotionListener.
   * Moves the object with mouse dragging operation.
   */
  public void mouseDragged(MouseEvent e){
    this.SetOwnSpots();

  }
/**
 *   Invoked when the component's size changes.
 */
  public void componentResized(ComponentEvent e) {this.SetOwnSpots();}
  /**
   * Invoked when the component's position changes.
   */
  public void componentMoved(ComponentEvent e){
    this.SetOwnSpots();
  }
  /**
   * Invoked when the component has been made visible.
   */
  public void componentShown(ComponentEvent e){}
  /**
   *  Invoked when the component has been made invisible.
   */
  public void componentHidden(ComponentEvent e){}
}
