package erkka;

import java.awt.Panel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.ImageIcon;
/**
 * Title:        Erkka-Projekti
 * Description:  This class defines top panel of the application. Top panel include all
 *  		 Buttons.
 * Copyright:    Copyright (c) 2002
 * @author        Antti Enqvist & Juho Yli-Honkola
 * @version 1.0
 */

public class TopPanel extends JPanel{
/*
/**
* by pressing entity button you can draw a box
*/
  JToggleButton EntityButton =new JToggleButton();
/**
* by pressing Attribute button you can draw oval
*/
  JToggleButton AttributeButton = new JToggleButton();
/**
* by pressing relation button you can draw a diamond
*/  JToggleButton RelationButton = new JToggleButton();
/**
* by pressing line button you can draw a line
*/  JToggleButton LineButton = new JToggleButton();
/**
* by pressing clearall button you can set all button up
*/  JButton ClearAllButton = new JButton();
/**
* Selected attribute tells which object has selected
*/

  String Selected="";


  public TopPanel() {
    setBackground(Color.gray);

 /*   RelationButton.setText("Relationship");
    RelationButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_clicked(e);
      }
    });
    this.add(RelationButton, null);

    AttributeButton.setText("Attribute");
    AttributeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_clicked(e);
      }
    });
    this.add(AttributeButton, null);

    EntityButton.setText("Entity");
    EntityButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_clicked(e);
      }
    });
    this.add(EntityButton,null);

    LineButton.setText("Line");
    LineButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_clicked(e);
      }
    });
    this.add(LineButton,null);

*/
    ClearAllButton.setIcon(new ImageIcon(erkka.MainWindow.class.getResource("arrow.gif")));
    ClearAllButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        NullSelected();
      }
    });


  }
/**
* Invokes when some of buttons will be clicked. Selected will be selected object name
*/
  private void Button_clicked(ActionEvent e){
      if( !((JToggleButton)e.getSource()).isSelected())
        SetSelected(null);
      else
        SetSelected((((JToggleButton)e.getSource()).getText()));
  }

/**
* return selected object name
*/
  public String GetSelected(){return Selected;}

/**
* This function sets emptys selected attribute
*/
  public void NullSelected(){SetSelected("");}

/**
* This function creates buttons. Button name is param text
*@param text the name of the button
*/
  public void addNewButton(String text){
    JToggleButton B =new JToggleButton();
    B.setText(text);

    B.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {Button_clicked(e);}});

    this.add(B, null);
  }

/**
* Invokes when button will be pressed
*/
  public void click(String buttonText){
    for( int i=0;i<this.getComponentCount();i++){
      if(getComponent(i) instanceof JToggleButton){
        JToggleButton b=(JToggleButton)getComponent(i);
        if (b.getText().equalsIgnoreCase(buttonText)){
          b.doClick();
          return;
        }
      }
    }

  }

/**
* This function sets selected object name into selected attribute
*/
  public void SetSelected(String name){
    Selected = name;
    for (int i=0;i<this.getComponentCount();i++)
    {
      if ((this.getComponent(i) instanceof JToggleButton) && ((JToggleButton)this.getComponent(i)).getText() != name)
        ((JToggleButton)this.getComponent(i)).getModel().setSelected(false);
    }
  }

/**
* this function creates clearbutton
*/
  public void createClearButton(){
        this.add(ClearAllButton, 0);
  }
}