<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"/>
<!--Here is added every attri right entity and relation-->
<!--pure data is just copied-->
<xsl:template match="/">
<all>
<xsl:apply-templates select="all/entity" />
<xsl:apply-templates select="all/relation" />
</all>
</xsl:template>

<xsl:template match="all/entity">
<xsl:variable name="first" select="id">
 <xsl:value-of select="id" />
</xsl:variable>
<entity>
<id><xsl:value-of select="id" /></id>
<name><xsl:value-of select="name" /></name>
<xsl:for-each select="idt">
<xsl:if test="not(id1=//attri/id)">
<xsl:if test="id1=not(empty)">
<idt>
<id1><xsl:value-of select="id1"/></id1>
<link><xsl:value-of select="link"/></link>
</idt>
</xsl:if>
</xsl:if>
</xsl:for-each>
<xsl:for-each select="idt">
<xsl:variable name="second" select="id1">
 <xsl:value-of select="id1" />
</xsl:variable>
<xsl:for-each select="//attri">
<xsl:if test="$second=id">
<xsl:if test="$first=//id">
<attri>                                       <!--Here is added right attris to entity-->
<id><xsl:value-of select="id" /></id>
<name><xsl:value-of select="name" /></name>
<type><xsl:value-of select="type" /></type>
<length><xsl:value-of select="length" /></length>
<compu><xsl:value-of select="compu" /></compu>
<xsl:if test="primary=not(empty)">
<primary><xsl:value-of select="primary" /></primary>
</xsl:if>
<xsl:if test="index=not(empty)">
<index><xsl:value-of select="index" /></index>
</xsl:if>
<xsl:if test="default=not(empty)">
<default><xsl:value-of select="default" /></default>
</xsl:if>
<xsl:for-each select="range">
<range><xsl:value-of select="./." /></range>
</xsl:for-each>
</attri>
</xsl:if>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</entity>
</xsl:template>

<xsl:template match="all/relation">
<xsl:variable name="fourth" select="id">
 <xsl:value-of select="id" />
</xsl:variable>
<relation>
<id><xsl:value-of select="id" /></id>
<name><xsl:value-of select="name" /></name>
<idtt>
<xsl:for-each select="//all/entity">
<xsl:if test="idt/id1=not(empty) and idt/link=not(empty)">

<xsl:for-each select="idt">
<xsl:if test="$fourth=id1">
<idt>
<id1><xsl:value-of select="parent::node()/id"/></id1>
<link><xsl:value-of select="link"/></link>
</idt>
</xsl:if>
</xsl:for-each>
</xsl:if>
</xsl:for-each>
</idtt>
<xsl:for-each select="adt">
<xsl:variable name="fifth" select="id1">
 <xsl:value-of select="id1" />
</xsl:variable>
<xsl:for-each select="//attri">
<xsl:if test="$fifth=id">
<attri>                                   <!--Here is added right attris to relation-->
<id><xsl:value-of select="id" /></id>
<name><xsl:value-of select="name" /></name>
<type><xsl:value-of select="type" /></type>
<length><xsl:value-of select="length" /></length>
<compu><xsl:value-of select="compu" /></compu>
<xsl:if test="primary=not(empty)">
<primary><xsl:value-of select="primary" /></primary>
</xsl:if>
<xsl:if test="index=not(empty)">
<index><xsl:value-of select="index" /></index>
</xsl:if>
<xsl:if test="default=not(empty)">
<default><xsl:value-of select="default" /></default>
</xsl:if>
<xsl:for-each select="range">
<range><xsl:value-of select="./." /></range>
</xsl:for-each>
</attri>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</relation>
</xsl:template>

</xsl:stylesheet>
