package erkka;

import java.awt.*;
import java.awt.Graphics2D;
import java.awt.font.*;
import java.awt.geom.*;
import java.util.Vector;
import java.awt.event.*;

  /**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  This class is rectangle container. This can contain other
*			symbols and move them when itself moves.</p>
*<p<Copyright:    Copyright (c) 2002</p>
*@author          Juho Yli-Honkola
*@version 1.0
*/

public class BoxContainer extends SymbolContainer {

  public BoxContainer() {
  }

/**
* This function draws a symbol in the shape of the rectangle
* @param g
*/
  public void paint(Graphics g){
 //   super.paint(g);
/**
* The size of the canvas
*/
    int CanvasWidth = this.getWidth(), CanvasHeight = this.getHeight();
/**
* The size of the object
*/

    int RectWidth, RectHeight;

        g2 = (Graphics2D) g;
      //  int width = 1;
      //  g2.setStroke(new BasicStroke(width));
      FontRenderContext frc = g2.getFontRenderContext();
      TextLayout tl;

      if (getFieldData(1).length()==0)
       { tl= new TextLayout(" ", f, frc);}

      else {String s = new String(getFieldData(1));tl = new TextLayout(s, f, frc);}
      Rectangle2D r2d = tl.getBounds();
      RectWidth = (int)r2d.getWidth()+20;
      RectHeight = this.getHeight()-2;

      if (RectWidth < 80){
        RectWidth = 80;
      }
      CanvasWidth = RectWidth+2;
      tl.draw(g2,7,f.getSize()/2+15);
      if (obj_focus) {g2.setColor(Color.red);}
      else { /*g2.setColor(Color.black);*/}
      //g2.drawRect(0,0,RectWidth,RectHeight);

      if(boxWidth<CanvasWidth){
        boxWidth=CanvasWidth;
      }
      if(change){
        boxWidth=getWidest(CanvasWidth);
      }
      this.setBounds(getX(),getY(),boxWidth,heig);
      g2.drawRect(0,0,getWidth()-1,getHeight()-1);
      g2.drawLine(0,29,getWidth(),29);
  }

/**
* Invokes when component moves. It also moves all symbol which are place into it.
* @param e
*/
  public void componentMoved(ComponentEvent e){
    int x=getX();
    int y=getY();
    for(int i=0;i<table.size();i++){
      BaseObject ba=(BaseObject)table.get(i);
      ba.setBounds(x,y+ba.getHeight()*i+30,ba.getWidth(),ba.getHeight());
    }
  repaint();
  }
}
