package erkka;

import java.util.Vector;
import java.awt.Point;
/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  Container class of hotspots</p>
*<p<Copyright:    Copyright (c) 2002</p>
*@author          Antti Enqvist
*@version 1.0
*/

public class HotSpots{
  private Vector SpotTable = new Vector();
  public HotSpots() {
  }

  public void SetSpotToTable(HotSpot spot){
  SpotTable.add(spot);
  }
  public HotSpot GetSpotFromTable(int i){
    return ((HotSpot)SpotTable.elementAt(i));
  }

/**
* returns a nearest hotspot.
* @param foo control point
*/
  public HotSpot GetNearestHotSpot(Point foo){
    double Dist = 0;                                          //shortest distance
    double old_Dist = 99999;                              //longest distance the is
    int index = -1;                                           //index which contains shortets distance in HotSpots vector
    for (int i=0;i<SpotTable.size();i++){
	//counts distance between foo and hot spot
      Dist = foo.distance(((HotSpot)SpotTable.elementAt(i)).getX(),((HotSpot)SpotTable.elementAt(i)).getY());

      if (Dist<old_Dist){
        index = i;                                            //new shortest distance
        old_Dist = Dist;
      }
    }
    return ((HotSpot)SpotTable.elementAt(index));
}

}