package erkka;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: Erkka-Projekti</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Erkka</p>
 * @author Jukka Mntyl
 * @version 1.2
 */

public class MainWindow_ConnectODBC extends JDialog {
  JPanel panel1 = new JPanel();
  ODBCQuery query;
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JTextField databaseText = new JTextField();
  JTextField userText = new JTextField();
  JPasswordField passText = new JPasswordField();
  JTextField driverText = new JTextField();
  JTextField protocolText = new JTextField();
  JPanel jPanel1 = new JPanel();
  JButton Connect = new JButton();
  JButton Cancel = new JButton();
  //int locx, locy;

  public MainWindow_ConnectODBC(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    //locx = startlocx;
    //locy = startlocy;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
/*
  public MainWindow_ConnectODBC() {
    this(null, "", false, null);
  }
*/
  private void jbInit() throws Exception {
    panel1.setLayout(gridBagLayout1);
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel1.setPreferredSize(new Dimension(67, 16));
    jLabel1.setText("JDBC Driver");
    jLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel2.setText("Protocol");
    jLabel3.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel3.setText("Database");
    jLabel4.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel4.setToolTipText("");
    jLabel4.setText("User");
    jLabel5.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel5.setText("Password");
    driverText.setFont(new java.awt.Font("Dialog", 0, 12));
    driverText.setPreferredSize(new Dimension(200, 22));
    driverText.setText("sun.jdbc.odbc.JdbcOdbcDriver");
    protocolText.setFont(new java.awt.Font("Dialog", 0, 12));
    protocolText.setPreferredSize(new Dimension(200, 22));
    protocolText.setText("jdbc:odbc:");
    databaseText.setFont(new java.awt.Font("Dialog", 0, 12));
    databaseText.setMinimumSize(new Dimension(200, 22));
    databaseText.setPreferredSize(new Dimension(200, 22));
    databaseText.setText("");
    Connect.setText("Connect");
    Connect.addActionListener(new MainWindow_ConnectODBC_Connect_actionAdapter(this));
    Cancel.setText("Cancel");
    Cancel.addActionListener(new MainWindow_ConnectODBC_Cancel_actionAdapter(this));
    userText.setFont(new java.awt.Font("Dialog", 0, 12));
    userText.setMinimumSize(new Dimension(200, 22));
    userText.setPreferredSize(new Dimension(200, 22));
    userText.setText("");
    passText.setMinimumSize(new Dimension(200, 23));
    passText.setPreferredSize(new Dimension(200, 23));
    passText.setText("");
    this.setDefaultCloseOperation(3);
    jPanel1.add(Connect, null);
    getContentPane().add(panel1);
    panel1.add(jLabel1,                   new GridBagConstraints(0, 0, 4, 1, 0.5, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    panel1.add(jLabel2,                 new GridBagConstraints(0, 1, 5, 1, 0.5, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    panel1.add(jLabel3,               new GridBagConstraints(0, 2, 4, 1, 0.5, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    panel1.add(jLabel4,            new GridBagConstraints(0, 3, 3, 1, 0.5, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    panel1.add(jLabel5,            new GridBagConstraints(0, 4, 1, 1, 0.5, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    panel1.add(driverText,             new GridBagConstraints(1, 0, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(protocolText,            new GridBagConstraints(1, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(databaseText,          new GridBagConstraints(1, 2, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    setResizable(false);
    panel1.add(jPanel1,         new GridBagConstraints(1, 5, 3, 1, 1.0, 2.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(Cancel, null);
    panel1.add(userText,   new GridBagConstraints(1, 3, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(passText,    new GridBagConstraints(1, 4, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

    //this.setLocation(locx,locy);
  }

  public ODBCQuery getQuery() {
    return query;
  }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      dispose();
    }
    super.processWindowEvent(e);
  }

  void Cancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  void Connect_actionPerformed(ActionEvent e) {
    if ( (driverText.getText().length() > 0) && (protocolText.getText().length() > 0) && (databaseText.getText().length() > 0)) {
      query = new ODBCQuery(driverText.getText(),
                            protocolText.getText() + databaseText.getText(),
                            userText.getText(), new String(passText.getPassword()));
      try {
        query.connect();

        dispose();
      }
      catch (Exception exc) {
        MessageBox msg = new MessageBox();
        msg.setTitle("Connect error.");
        msg.askOkay(exc.getMessage());
      }
    }
    else {
      MessageBox msg = new MessageBox();
      msg.setTitle("Connect error.");
      msg.askOkay("Insufficient parameters. Fill all fields.");
    }
  }

}


class MainWindow_ConnectODBC_Cancel_actionAdapter implements java.awt.event.ActionListener {
  MainWindow_ConnectODBC adaptee;

  MainWindow_ConnectODBC_Cancel_actionAdapter(MainWindow_ConnectODBC adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Cancel_actionPerformed(e);
  }
}

class MainWindow_ConnectODBC_Connect_actionAdapter implements java.awt.event.ActionListener {
  MainWindow_ConnectODBC adaptee;

  MainWindow_ConnectODBC_Connect_actionAdapter(MainWindow_ConnectODBC adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Connect_actionPerformed(e);
  }
}

/*
    getRootPane().getActionMap().put("close",
       new AbstractAction()
       {
          public void actionPerformed(ActionEvent e)
          {

          }
       }

    );

    int stdMask = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
    InputMap im =
    getRootPane().getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
    im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "close");
*/


