//
// PNGException.java
//
// Author: Walter Brameld
// Date: 3/30/2001
//
// Purpose: Thrown by a PNGEncoder if an error involving the image occurs.
//

package erkka;

/**
 * Thrown by a <tt>PNGEncoder</tt> if an error involving the image occurs.
 */
public class PNGException extends ImageException {

    /**
     * Creates a <tt>PNGException</tt> with no detail message.
     */
    public PNGException() {
        super();
    }  // end PNGException()


    /**
     * Creates a <tt>PNGException</tt> with the given detail message.
     */
    public PNGException( String detail ) {
        super( detail );
    }  // end constructor

}  // end class PNGException
