package erkka;

import javax.swing.*;
import java.awt.event.*;

/**
 * Title:        Erkka-Projekti
 * Description:  Property data field extends JTextFields, so this class is shown in 
 *			the infopanel as a textbox
 * Copyright:    Copyright (c) 2002
 * Company:      Erkka
 * @author
 * @version 1.0
 */

public class PropDataField extends JTextField implements ComponentListener{

  int indexInTable=-5;
  JComponent comp;
  public PropDataField() {

  }
  public void setComponentOverSelf(JComponent component){
    if(component==null){
      setVisible(true);
      comp=null;
      return;
    }

    comp=component;
    comp.setBounds(getBounds());
    //setVisible(false);


  }
/**
* Moves component vertically up or down
* @param down defies how many pixel this componen will be moved
*/
  public void moveUpOrDown(int down){
    setBounds(getX(),getY()+down,getWidth(),getHeight());
    if(comp!=null)
      comp.setBounds(getBounds());
  }


  public void setIndex(int i){
    indexInTable=i;
    if(comp!=null)comp.setName(String.valueOf(i));
  }

  public int getIndexInT(){return indexInTable;}

  public void componentHidden(ComponentEvent e){;}
  public void componentResized(ComponentEvent e){;}
  public void componentShown(ComponentEvent e){;}
  public void componentMoved(ComponentEvent e){
    comp.setBounds(getBounds());
  }

}