package erkka;
import java.util.*;

/**
 * <p>Title: Erkka-Projekti</p>
 * <p>Description: This function includes a vector which contains all the fields
 *     		 which are shown in the infopanel</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Erkka</p>
 * @author Jukka Mntyl
 * @version 1.2 getExtraFieldByName-metodi
 */

public class SelectionBox {
  String name,type;
  Vector choices =new Vector();
  public SelectionBox(String name,String type) {
  this.name=name;
  this.type=type;

  }
  public String getName(){return name;}
  public int getChoiceCount(){return choices.size();}
  public String getTypeName(){return type;}
  public String getChoiceName(int i){
    return ((Choice)choices.get(i)).getName();

  }
  /**
   * This method returns Proper object if in
   */
  public Proper getExtrafield(String choice){
    for(int i=0;i<choices.size();i++){
      Choice c=(Choice)choices.get(i);
      if(c.getName().equalsIgnoreCase(choice)){
        if(c.getFieldName()==null || c.getFieldName().length()<=1)
          return null;
        Proper pro= new Proper(c.getFieldName());
        pro.setPData(c.getFieldData());
        return pro;
      }
    }
    return null;
  }

  // jos tiedetn jo nimi niin tll saa proper(tyn)
  public Proper getExtrafieldByName(String fieldname) {
    for(int i=0;i<choices.size();i++){
      Choice c=(Choice)choices.get(i);
      if ( c.getFieldName() !=null )
        if (c.getFieldName().equalsIgnoreCase(fieldname)) {
          Proper pro = new Proper(c.getFieldName());
          pro.setPData(c.getFieldData());
          return pro;
      }
    }
    return null;
  }

    /** if choice needs extra datafield, example
     *  example VARCHAR needs lenght it is in proper;
    */
    public void addChoice(String name,Proper extra){
    Choice c=new Choice(name,extra);
    choices.add(c);

  }

}
