package erkka;
import java.awt.*;
import java.awt.Graphics2D;
import java.awt.font.*;
import java.awt.geom.*;
import java.util.Vector;
import java.awt.event.*;
/**
 * <p>Title: Erkka-Projekti</p>
 * <p>Description: Thos class can contain other symbols, it move symbols
 * when itself moves. </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Juho Yli-Honkola
 * @version 1.0
 */

public class SymbolContainer extends Symbol {
  protected Font f = new Font("Times",Font.BOLD, 13);
  public Vector table =new Vector();
  protected boolean change=true;
  protected int boxWidth=0;
  protected int counter =0;
  protected int heig=30;
  public SymbolContainer() {


  }
  /**
   * Add symbol top of this component. Set right place for component and add
   * it in table where are all symbols.
   * @param s
   */
  public void addSymbol(Symbol s){
    table.add(s);
  //  s.repaint();
    if(s.getWidth()>getWidth())setSize(s.getWidth(),getHeight());
    s.drawYourselfBounds(false);
    //find place, put symbol down
    if(table.size()>1){
      Symbol temp=(Symbol)table.get(table.size()-2);
      s.setBounds(temp.getX(),temp.getY()+temp.getHeight()+2,s.getWidth(),s.getHeight());
    }
    else // first symbol place is 30 pixel down
      s.setBounds(getX(),getY()+30,s.getWidth(),s.getHeight());
    heig=s.getY()-getY()+s.getHeight();
    setBounds(getX(),getY(),getWidth(),heig);
  }
  public void deleleSymbol(int index){

    table.remove(index);
    setBounds(getX()+1,getY(),getWidth(),getHeight());
    setBounds(getX()-1,getY(),getWidth(),getHeight());
    if(table.size()<1){
    heig=40;
    setBounds(getX(),getY(),getWidth(),heig);
    }
    else{
      heig=heig-((BaseObject)table.get(0)).getHeight();

      setBounds(getX(),getY(),getWidth(),heig);
    }



  }

/**
* Invokes when mouse is pressed
*/
  public void mousePressed(MouseEvent e){
/*    int x=e.getX();
    int y=e.getY();
    BaseObject b=this;
    // count what attribute is clikked
    for(int i=0;i<table.size();i++){
     BaseObject base=(BaseObject)table.get(i);
      if( (base.getY()-getY())<y && (base.getY()-getY()+base.getHeight())>y)
        b=base;
      break;

    }

    if(b==this)return;

/* MouseListener[] list= (MouseListener[])(this.getListeners(MouseListener.class));
   for(int i=0;i<list.length;i++){
      this.removeMouseListener(list[i]);
    }
*/
    // mouseEvent for attribute
/*    MouseListener[] als = (MouseListener[])(b.getListeners(MouseListener.class));
    for(int i=0;i<als.length;i++)
      als[i].mousePressed(new MouseEvent(b,MouseEvent.MOUSE_PRESSED,e.getWhen(),e.getModifiers(),5,5,e.getClickCount(),e.isPopupTrigger()));

/*    for(int i=0;i<list.length;i++){
      this.addMouseListener(list[i]);
    }*/
  }

  /**
   * Overload this method
   * @param g
   */
  public void paint(Graphics g){
  }

  /**
   * Method returns widest attribute value.
   * @param CanvasWidth
   * @return
   */
  protected int getWidest(int CanvasWidth){
    int w1=0,w2=0;
    for(int i=0;i<table.size();i++){
      if( ((BaseObject)table.get(i)).getWidth()>w1){
        w1=((BaseObject)table.get(i)).getWidth();
      }
    }
    if(w1>CanvasWidth){
      CanvasWidth=w1;
    }
    return CanvasWidth;
  }
  public void componentMoved(ComponentEvent e){
  }
}
